
module DM
module ProfileBuilder2
module AF_com_tool

class DrawComTool
  def self.load_menu
    tool_bar = UI::Toolbar.new("TC-放样绘制")
    
    menu = UI.menu("Plugins")
    menu = menu.add_submenu(%Q(TC-放样绘制))
    #################################################################################################################
    menu.add_item("载入柜子") {self.insert}#0
    menu.add_item("5点绘制柜子") {
      skp_path = UI.openpanel("打开 SKP 文件", '', 'SketchUp File|*.skp;||')
      self.draw(skp_path) if skp_path
      # self.draw( File.join(DrawComTool.get_dir,"TCTY.skp"))#调试用
    }
	menu.add_item("截面放样") {ProfileBuilderTool.create.show}#2
	menu.add_item("智能构件") {FenceBuilderTool.create.show}#3
	menu.add_item("绘制下柜") 	  {self.draw(File.join(DrawComTool.get_dir,"TCTY4.skp"))}#4
	menu.add_item("绘制上柜")     {self.draw(File.join(DrawComTool.get_dir,"TCTY5.skp"))}#5
  menu.add_item("绘制一字桌框") {self.draw(File.join(DrawComTool.get_dir,"TCTY6.skp"))}#6
  menu.add_item("绘制抽屉")     {self.draw(File.join(DrawComTool.get_dir,"TCTY11.skp"))}#11
	menu.add_item("绘制智能立板") {self.draw(File.join(DrawComTool.get_dir,"TCTY7.skp"))}#7
	menu.add_item("绘制参数层板") {self.draw(File.join(DrawComTool.get_dir,"TCTY8.skp"))}#8
	menu.add_item("绘制立板")     {self.draw(File.join(DrawComTool.get_dir,"TCTY9.skp"))}#9
	menu.add_item("绘制层板")     {self.draw(File.join(DrawComTool.get_dir,"TCTY10.skp"))}#10
	menu.add_item("绘制封板")     {self.draw(File.join(DrawComTool.get_dir,"TCTY12.skp"))}#12	

	
    ########################################################################################################
	
	
	
    command = UI::Command.new(""){self.insert}#0
    command.small_icon = File.join(self.get_dir,'tc1.png')
    command.large_icon = File.join(self.get_dir,'tc1.png')
    command.tooltip = %Q(载入柜子)
    command.status_bar_text = ("载入柜子，自定义的柜子...")
    tool_bar.add_item command#0
	command = UI::Command.new(""){
      skp_path = UI.openpanel("打开 SKP 文件", '', 'SketchUp File|*.skp;||')
      self.draw(skp_path) if skp_path
      # self.draw( File.join(DrawComTool.get_dir,"TCTY.skp"))#调试用
    }
    command.small_icon = File.join(self.get_dir,'tc2.png')
    command.large_icon = File.join(self.get_dir,'tc2.png')
    command.tooltip = %Q(5点绘制柜子)
    command.status_bar_text = ("第一点为参考点/四点绘柜体")  
    tool_bar.add_item command#1
  
	
	
	
	
    	command = UI::Command.new(""){ProfileBuilderTool.create.show}
    command.small_icon = File.join(self.get_dir,'profilemember.png')
    command.large_icon = File.join(self.get_dir,'profilemember.png')
    command.tooltip = %Q(截面放样)
    command.status_bar_text = ("添加截面调整放样")  
    tool_bar.add_item command#1
	
	
    	command = UI::Command.new(""){FenceBuilderTool.create.show}
    command.small_icon = File.join(self.get_dir,'apply.png')
    command.large_icon = File.join(self.get_dir,'apply.png')
    command.tooltip = %Q(智能构件)
    command.status_bar_text = ("载入/吸取/绘制智能构件")  
    tool_bar.add_item command#1
   
   
      tool_bar.add_separator  
   
 
    command = UI::Command.new(""){

	self.draw(File.join(DrawComTool.get_dir,"TCTY4.skp"))
	
	}
	command.small_icon = File.join(self.get_dir,'TCTY4.png')
    command.large_icon = File.join(self.get_dir,'TCTY4.png')
    command.tooltip = %Q(绘制下柜)
    command.status_bar_text = ("第一点为参考点/四点绘制下柜")   
    tool_bar.add_item command#1
    command = UI::Command.new(""){
	
	self.draw(File.join(DrawComTool.get_dir,"TCTY5.skp"))
	
	}
    
	command.small_icon = File.join(self.get_dir,'TCTY5.png')
    command.large_icon = File.join(self.get_dir,'TCTY5.png')
    command.tooltip = %Q(绘制上柜)
    command.status_bar_text = ("第一点为参考点/四点绘制上柜")
     tool_bar.add_item command#1

    command = UI::Command.new(""){
	
	self.draw(File.join(DrawComTool.get_dir,"TCTY6.skp"))
	
	}
    
	command.small_icon = File.join(self.get_dir,'TCTY6.png')
    command.large_icon = File.join(self.get_dir,'TCTY6.png')
    command.tooltip = %Q(绘制一字桌框)
    command.status_bar_text = ("第一点为参考点/四点绘制一字桌框")
    tool_bar.add_item command#1



    command = UI::Command.new(""){
	
      self.draw(File.join(DrawComTool.get_dir,"TCTY11.skp"))
      
      }
        
      command.small_icon = File.join(self.get_dir,'TCTY11.png')
        command.large_icon = File.join(self.get_dir,'TCTY11.png')
        command.tooltip = %Q(绘制抽屉)
        command.status_bar_text = ("第一点为参考点/四点绘制抽屉")
        tool_bar.add_item command#1



    command = UI::Command.new(""){
	
	self.draw(File.join(DrawComTool.get_dir,"TCTY7.skp"))
	
	}
    
	command.small_icon = File.join(self.get_dir,'TCTY7.png')
    command.large_icon = File.join(self.get_dir,'TCTY7.png')
    command.tooltip = %Q(绘智能立板)
    command.status_bar_text = ("第一点为参考点/四点绘制立板")
     tool_bar.add_item command#1
    command = UI::Command.new(""){
	
	self.draw(File.join(DrawComTool.get_dir,"TCTY8.skp"))
	
	}
    
	command.small_icon = File.join(self.get_dir,'TCTY8.png')
    command.large_icon = File.join(self.get_dir,'TCTY8.png')
    command.tooltip = %Q(绘制参数层板)
    command.status_bar_text = ("第一点为参考点/四点绘制参数层板")
    tool_bar.add_item command#1
    command = UI::Command.new(""){
	
	self.draw(File.join(DrawComTool.get_dir,"TCTY9.skp"))
	
	}
    
	command.small_icon = File.join(self.get_dir,'TCTY9.png')
    command.large_icon = File.join(self.get_dir,'TCTY9.png')
    command.tooltip = %Q(绘制立板)
    command.status_bar_text = ("第一点为参考点/四点绘制立板")
    tool_bar.add_item command#1
	command = UI::Command.new(""){
	
	self.draw(File.join(DrawComTool.get_dir,"TCTY10.skp"))
	
	}
    
	command.small_icon = File.join(self.get_dir,'TCTY10.png')
    command.large_icon = File.join(self.get_dir,'TCTY10.png')
    command.tooltip = %Q(绘制层板)
    command.status_bar_text = ("第一点为参考点/四点绘制层板")
    
    tool_bar.add_item command#1



    
	command = UI::Command.new(""){
	
	self.draw(File.join(DrawComTool.get_dir,"TCTY12.skp"))
	
	}
    
	command.small_icon = File.join(self.get_dir,'TCTY12.png')
    command.large_icon = File.join(self.get_dir,'TCTY12.png')
    command.tooltip = %Q(绘制封板)
    command.status_bar_text = ("第一点为参考点/四点绘制封板")
    
    tool_bar.add_item command#1

##########################################################

   state = tool_bar.get_last_state
    if(state == TB_NEVER_SHOWN)
      tool_bar.show
    else
      tool_bar.show unless tool_bar.visible?
      tool_bar.restore
    end
  end

  
  def self.options
	  if $dc_observers.get_latest_class.configure_dialog_is_visible
	  $dc_observers.get_latest_class.close_configure_dialog
	  else
	  $dc_observers.get_latest_class.show_configure_dialog
	  end
	  Sketchup.send_action("selectSelectionTool:")
 end
  
  
  def self.click
	  Sketchup.active_model.select_tool(DCInteractTool.new($dc_observers))
 end
  
  
  
  def self.get_dir
    file = __FILE__.dup
    file.force_encoding("UTF-8") if file.respond_to?(:force_encoding)
    f = File.basename(file, '.*').freeze
    r = File.dirname(file).freeze
    return File.join(r,f)
  end

  def self.draw(path)
    Sketchup.active_model.select_tool(self.new(path))
  end

  def self.insert
    model = Sketchup.active_model
    stripwood_path = UI.openpanel("打开 SKP 文件", '', 'SketchUp File|*.skp;||')
    stripwood_def = model.definitions.load stripwood_path
    model.place_component(stripwood_def)
  end
  
  def self.options
    if $dc_observers.get_latest_class.configure_dialog_is_visible
      $dc_observers.get_latest_class.close_configure_dialog
    else
      $dc_observers.get_latest_class.show_configure_dialog
    end
    Sketchup.send_action("selectSelectionTool:")
  end




  def initialize(path)
    @ip  = Sketchup::InputPoint.new
    @ip1 = Sketchup::InputPoint.new
    @ip2 = Sketchup::InputPoint.new
    @cline = nil
    @start_line = []
    @com = path.freeze
  end

  def reset(view = nil)
    @points = []
    @height = 0
    @state = -1
    @ip.clear
    @ip1.clear
    @ip2.clear
    @start_line = []
    @face_normal = Z_AXIS
    if @cline&&@cline.valid?
      @cline.erase!
    end
    @cline = nil
    view.invalidate if view
    view.lock_inference if view && view.inference_locked?
    Sketchup::set_status_text "", SB_VCB_LABEL
    Sketchup::set_status_text "", SB_VCB_VALUE
    Sketchup::set_status_text "点击参考点"
  end

  def activate
    @edit_transform = axes_edit_transform
    self.reset
  end

  def deactivate(view)
    self.reset(view)
  end

  def axes_edit_transform
    model=Sketchup.active_model
    return model.axes.transformation if Sketchup.version.to_i>=16
    model.start_operation "get edit transform"
    ents=model.active_entities
    begin
      g=ents.add_group(ents.add_group) 
      t=Geom::Transformation.new(g.transformation.xaxis,g.transformation.yaxis,g.transformation.zaxis,g.transformation.origin)
      g.erase! if g && g.valid? && !g.deleted? 
    rescue
      t=model.edit_transform
    end
    model.abort_operation
    return t
  end

  def set_current_point(x, y, view)
    case @state
    when -1
      @ip.pick view, x, y
      @ip2.copy! @ip
    when 0
      @ip.pick view, x, y,@ip2
      @ip1.copy! @ip
      if @ip1.valid?
        @points[0] = @ip1.position
        @points[4] = @points[0]
      end
      width = @ip2.position.distance @ip.position
      Sketchup::set_status_text width.to_s, SB_VCB_VALUE
    when 1
      @points[0] = @ip1.position
      @points[4] = @points[0]
      return nil if( !@ip.pick(view, x, y, @ip1) )
      if @ip.valid?
        @points[1] = @ip.position
        @width = @points[0].distance @points[1]
        Sketchup::set_status_text @width.to_s, SB_VCB_VALUE
      end
    when 2
      return nil if(!@ip.pick(view, x, y,@ip1))
      if @ip.valid?
        return nil if @ip==@ip1
        pt1 = @ip.position
        pt2 = pt1.project_to_line @points
        vec = pt1 - pt2
        @depth = vec.length
        if( @depth > 0 )
          square_point = pt2.offset(vec, @width)
          if( view.pick_helper.test_point(square_point, x, y) )
            @depth = @width
            @points[2] = @points[1].offset(vec, @depth)
            @points[3] = @points[0].offset(vec, @depth)
            view.tooltip = "Square"
          else
            @points[2] = @points[1].offset(vec)
            @points[3] = @points[0].offset(vec)
          end
        else
          @points[2] = @points[1]
          @points[3] = @points[0]
        end
        Sketchup::set_status_text @depth.to_mm.round(2).to_s, SB_VCB_VALUE
      end
    when 3
      @ip.pick view, x, y,@ip1
      if @ip.valid?
        v1 = @points[1].vector_to(@points[0])
        v2 = @points[1].vector_to(@points[2])
        @face_normal = v1*v2.normalize
        @cline ||= Sketchup.active_model.entities.add_cline(@points[2],@face_normal)
        plane = [@points[0],@face_normal]
        pt1 = @ip.position
        length = pt1.distance_to_plane(plane)
        pt2  = pt1.project_to_plane plane
        vec = pt2.vector_to(pt1).normalize
        @face_normal = vec  if vec.valid?
        @height = length
        Sketchup::set_status_text @height.to_mm.round, SB_VCB_VALUE
      end
    end

    if @ip.valid?
      view.invalidate
      view.tooltip = @ip.tooltip
    end
  end

  def onMouseMove(flags, x, y, view)
    self.set_current_point(x, y, view)
  end

  def createGeometry(view)
    if @height>0
      model = Sketchup.active_model
      model.start_operation("Draw panel")
      ents = model.active_entities
      if File.exist? @com
        d = model.definitions.load @com
        b = d.bounds
        w = b.width
        dd = b.height
        h = b.depth
        sr = Geom::Transformation.scaling(@points[0],@width/w,@depth/dd,@height/h)
        x = @points[0].vector_to @points[1]
        y = @face_normal*x
        tr = Geom::Transformation.new(x,y,@face_normal,@points[0])
        c = ents.add_instance d,Geom::Transformation.new
        c.make_unique
        c.transform! sr
        $dc_observers.get_class_by_version(c).redraw_with_undo(c)
        c.transformation = tr
      end
      self.reset(view)
    else
      self.reset(view)
    end
  end

  def increment_state(view)
    @state += 1
    case @state
    when 0
      @ip1.copy! @ip
      @start_line[0] = @ip2.position
      Sketchup::set_status_text "点击起点"
      Sketchup::set_status_text "长度", SB_VCB_LABEL
      Sketchup::set_status_text "", SB_VCB_VALUE
    when 1
      @start_line[1] = @ip1.position
      @p1 = @ip1.position
      Sketchup::set_status_text "点击右/宽度"
      Sketchup::set_status_text "长度", SB_VCB_LABEL
      Sketchup::set_status_text "", SB_VCB_VALUE
    when 2
      @p2 = @ip1.position
      Sketchup::set_status_text "点击后/深度"
      Sketchup::set_status_text "长度", SB_VCB_LABEL
      Sketchup::set_status_text "", SB_VCB_VALUE
      view.lock_inference if view.inference_locked?
    when 3
      Sketchup::set_status_text "点击上/高度"
      Sketchup::set_status_text "高度", SB_VCB_LABEL
      Sketchup::set_status_text "", SB_VCB_VALUE
      view.lock_inference if view.inference_locked?
    when 4
      self.createGeometry(view)
    end
  end

  def onLButtonDown(flags, x, y, view)
    self.set_current_point(x, y, view)
    self.increment_state(view)
  end

  def onCancel(flag, view)
    self.reset(view)
  end
  def onUserText(text, view)
    begin
      value = text.to_l
    rescue
      UI.beep
      value = nil
      Sketchup::set_status_text "", SB_VCB_VALUE
    end
    return if !value
    case @state
    when 0
      vec = @ip.position-@ip2.position
      if( vec.length > 0.0 )
        vec.length = value
        @ip1 = Sketchup::InputPoint.new(@ip2.position.offset(vec))
        self.increment_state(view)
        view.invalidate
      end
    when 1
      vec = @points[1] - @points[0]
      if( vec.length > 0.0 )
        vec.length = value
        @width = value
        @points[1] = @points[0].offset(vec)
        view.invalidate
        self.increment_state(view)
      end
    when 2
      vec = @points[3] - @points[0]
      if( vec.length > 0.0 )
        vec.length = value
        @depth = value
        @points[2] = @points[1].offset(vec)
        @points[3] = @points[0].offset(vec)
        self.increment_state(view)
      end
    when 3
      @height = value
      self.increment_state(view)
    end
    view.invalidate
  end

  def draw(view)
    if( @ip.valid? && @ip.display? )
      @ip.draw(view)
    end
    self.drawGeometry(view)
  end

  def drawGeometry(view)
    view.line_width = 2
    case @state
    when 0
      view.set_color_from_line(@ip2, @ip)
      view.line_stipple = "-"
      view.draw_line(@ip2.position,@ip1.position)
    when 1
      view.line_stipple = ""
      view.set_color_from_line(@ip1, @ip)
      view.draw(GL_LINE_STRIP, @points[0], @points[1])
      view.line_stipple = "-"
      view.draw_line(@start_line)
    when 2
      view.line_stipple = ""
      view.drawing_color = "red"
      view.draw(GL_LINE_STRIP, @points)
      view.line_stipple = "-"
      view.draw_line(@start_line)
    when 3
      view.drawing_color = "red"
      view.line_stipple = ""
      view.draw(GL_LINE_STRIP, @points)
      points = @points.map{|pt| pt.offset(@face_normal,@height)}
      view.draw(GL_LINE_STRIP, points)
      points.each_with_index do |pt,i|
        view.draw(GL_LINE_STRIP, pt,@points[i])
      end
      view.line_stipple = "-"
      view.draw_line(@start_line)
    end
  end

  def getExtents
    bb = Geom::BoundingBox.new
    case @state
    when -1,0
      if( @ip.valid? && @ip.display? )
        bb.add @ip.position
      end
    else
      bb.add @points.compact
      bb.add @ip.position
    end
    bb
  end

  def onKeyDown(key, rpt, flags, view)
    if key==VK_UP  
      view.lock_inference if view.inference_locked?
      if @ip.valid? && @state>0 
        p= ((@state==1) ? @p1 : @p2)
        p1=p + @edit_transform.zaxis
        ip1 = Sketchup::InputPoint.new(p1)
        ip = Sketchup::InputPoint.new(p)
        view.lock_inference ip1,ip
      end
    elsif key==VK_LEFT
      view.lock_inference if view.inference_locked?
      if @ip.valid? && @state>0
        p=  ((@state==1) ? @p1 : @p2)
        p1=p + @edit_transform.yaxis
        ip1 = Sketchup::InputPoint.new(p1)
        ip = Sketchup::InputPoint.new(p)
        view.lock_inference ip1,ip
      end
    elsif key==VK_RIGHT
      view.lock_inference if view.inference_locked?
      if @ip.valid? && @state>0 
        p= ((@state==1) ? @p1 : @p2)
        p1=p + @edit_transform.xaxis
        ip1 = Sketchup::InputPoint.new(p1)
        ip = Sketchup::InputPoint.new(p)
        view.lock_inference ip1,ip
      end
    end
  end

  def onKeyUp(key, rpt, flags, view)
  end
end

DrawComTool.load_menu
end

end #module PB
end #module DM