require 'sketchup.rb'
module DM
module ProfileBuilder2
class DynamicFenceTool
include Geometry

def initialize(fence)
	@on_mac = (Object::RUBY_PLATFORM =~ /mswin/i) ? false : ((Object::RUBY_PLATFORM =~ /darwin/i) ? true : :other)
    @ip1 = nil
    @ip2 = nil
    @xdown = 0
    @ydown = 0
	@chain=Chain.new
	@fence=fence
	@fence_def=nil	#will store the fence definition
	plugins=PATH
	build_icon=File.join(plugins,"cursors/assembly_cursor.png")
	@cursor=UI.create_cursor(build_icon,1,1)
end
 
##
def activate
@ip1 = Sketchup::InputPoint.new
@ip2 = Sketchup::InputPoint.new
@ip = Sketchup::InputPoint.new
@last_point=Geom::Point3d.new(0,0,0)
@drawn = false
@hidden_members=[]
@fence_def=nil
@building=false
@operation_started=false
# This sets the label for the VCB
Sketchup::set_status_text("Length", SB_VCB_LABEL)
Sketchup::set_status_text(nil,SB_VCB_VALUE)
self.reset(nil)
end
###################################################
def deactivate(view)
ProfileBuilder2.clear_pmpi()
view.invalidate if @drawn
view.lock_inference
@fence_def=nil
Sketchup.active_model.commit_operation if @operation_started
end
#######################
def onSetCursor
UI.set_cursor(@cursor) if @cursor
end
##
def get_status_text()
case @state
when 0
	text="单击开始点. Ctrl=PMPI"
else
	text="点击下一个点或者输入距离； CTRL=PMPI；ESC、ENTER或者鼠标右键结束。"
end
return text
end

###################################################
#method to tell SU the extent of what to draw
def getExtents
box=Sketchup.active_model.bounds
box.add(@ip1.position) if @ip1.valid?
box.add(@ip.position) if @ip.valid?
box.add(@ip2.position) if @ip2.valid?
return box
end
####################################################
def onMouseMove(flags, x, y, view)
	@x_current=x
	@y_current=y
	
    if( @state == 0 )
		Sketchup::set_status_text(get_status_text(), SB_PROMPT)
        @ip.pick view, x, y
        if( @ip != @ip1 )
            view.invalidate if( @ip.display? or @ip1.display? )
            @ip1.copy! @ip
            view.tooltip = @ip1.tooltip
        end
    else
      	Sketchup::set_status_text(get_status_text(), SB_PROMPT)  
        @ip2.pick view, x, y, @ip1
        view.tooltip = @ip2.tooltip if( @ip2.valid? )
        view.invalidate
 	
		length = @ip1.position.distance(@ip2.position)
		Sketchup::set_status_text length.to_s, SB_VCB_VALUE
		
		#@chain.pop()
		#@last_point=@ip2.position
		#@chain.add(@last_point)
				
		#view.tooltip = @ip2.tooltip if( @ip2.valid? )
        #view.invalidate
		
        if( (x-@xdown).abs > 20 || (y-@ydown).abs > 20 )
            @dragging = true
        end
    end
end
def lock_axis(view,axis)
if view.inference_locked?
	view.lock_inference
end
if @state==1 and @ip2.valid?
	p2=@ip2.position
	p1=@ip1.position
	vec=p1.vector_to(p2)
	len=vec.dot(axis)
	len=1.0 if len==0.0
	offset_vector=Geom::Vector3d.new(axis)
	offset_vector.length=len
	@ip2=Sketchup::InputPoint.new(@ip1.position.offset(offset_vector))
	view.lock_inference(@ip1,@ip2)
end
end
###################################################
def onLButtonDown(flags, x, y, view) 
    if( @state == 0 )
        @ip1.pick view, x, y
        if( @ip1.valid? )
            @state = 1
			@last_point=@ip1.position
			@chain.add(@last_point)
			#@chain.add(@last_point.clone)
            Sketchup::set_status_text(get_status_text(), SB_PROMPT)
            @xdown = x
            @ydown = y
			Sketchup.active_model.start_operation("Build Assembly",true)
			@operation_started=true
        end
    else
        if( @ip2.valid? )			
				@last_point=@ip2.position
				@chain.add(@last_point)
				self.place_fence(view,true)
				@ip1=Sketchup::InputPoint.new(@ip2.position)
				#@ip1.copy! @ip2
				@drawn = false
				@dragging = false
				@left_down=@right_down=@up_down=@down_down=false
				if @chain.num_points>2 and @chain.first==@chain.last
					self.reset(view)
				#else
					#@chain.add(@last_point.clone)
				end
				#@ip2.clear
        end
    end
    
    # Clear any inference lock
    view.lock_inference
	view.invalidate
end
############################
def onLButtonUp(flags, x, y, view)
    # If we are doing a drag, then create the line on the mouse up event
   if(@dragging && @ip2.valid?)
		if @chain.num_points==1
			@last_point=@ip2.position
			@chain.add(@last_point)
			self.place_fence(view,true)
			@ip1.copy! @ip2
			@drawn = false
			@dragging = false
		end
   end
end
##
def onReturn(view)
self.reset(view)
end
##
def getMenu(menu)
if @chain.num_points>1
	menu.add_item('完成') {self.reset(Sketchup.active_model.active_view)}
end
end
#########################
def onKeyDown(key, repeat, flags, view)
case key
when VK_DELETE, 8
	if @chain.num_points>1
		@chain.pop()
		@last_point=@chain.last
		@ip1=Sketchup::InputPoint.new(@chain.last)
		if @chain.num_points>1
			self.place_fence(view,true)
		else
			delete_fence(view)
		end
	end
when CONSTRAIN_MODIFIER_KEY
	@shift_down_time = Time.now
	# if we already have an inference lock, then unlock it
	if( view.inference_locked? )
		# calling lock_inference with no arguments actually unlocks
		view.lock_inference
	elsif( @state == 0 && @ip1.valid? )
		view.lock_inference @ip1
	elsif( @state == 1 && @ip2.valid? )
		view.lock_inference @ip2, @ip1
	end
when VK_LEFT
	@left_down=!@left_down
	if @left_down
		lock_axis(view,Y_AXIS) 
	else
		view.lock_inference if view.inference_locked?
	end
	@right_down=@up_down=@down_down=false
when VK_RIGHT
	@right_down=!@right_down
	if @right_down
		lock_axis(view,X_AXIS) 
	else
		view.lock_inference if view.inference_locked?
	end
	@left_down=@down_down=@up_down=false
when VK_DOWN
	@down_down=!@down_down
	if @down_down
		lock_axis(view,Z_AXIS) 
	else
		view.lock_inference if view.inference_locked?
	end
	@up_down=@left_down=@right_down=false
when VK_UP
	@up_down=!@up_down
	if @up_down
		lock_axis(view,Z_AXIS) 
	else
		view.lock_inference if view.inference_locked?
	end
	@down_down=@left_down=@right_down=false
when COPY_MODIFIER_KEY
	pmpi(view,@x_current,@y_current)
end
view.invalidate
end
def pmpi(view,x,y)
ray=view.pickray(x,y)
rt=Sketchup.active_model.raytest(ray)
e=rt[1][0] if rt
if e and Classify.assembly?(e)	
	if !e.valid?
		UI.messagebox("实体无效")
	else
		Sketchup.active_model.start_operation("PMPI") unless @operation_started
		a=Assembly.get(e)
		a.pmpi()
		#Sketchup.active_model.commit_operation
	end			
end
end
#################
def onKeyUp(key, repeat, flags, view)
	
    if( key == CONSTRAIN_MODIFIER_KEY &&
        view.inference_locked? &&
        (Time.now - @shift_down_time) > 0.5 )
        view.lock_inference
    end
	view.invalidate
end
##
def onUserText(text, view)
  
    begin
        value = text.to_l
    rescue
        # Error parsing the text
        UI.beep
        puts "Cannot convert #{text} to a Length"
        value = nil
        Sketchup::set_status_text "", SB_VCB_VALUE
    end
    return if !value
    # Compute the direction and the second point
    pt1 = @ip1.position
    vec = @ip2.position - pt1
    if( vec.length == 0.0 )
        return
    end
    vec.length = value
    pt2 = pt1 + vec
	@last_point=pt2
	#@chain.pop()
	@chain.add(@last_point)
	#@chain.add(pt2)
	self.place_fence(view,true)
	ip_temp=Sketchup::InputPoint.new(pt2)   #Create a new inputpoint and set it to the point defined by the input length
	@ip1.copy! ip_temp
	#@ip2.copy! ip_temp
	@drawn = false
  	@dragging = false
	#@chain.add(@last_point.clone)
end
##
def draw(view)
if( @ip1.valid? )
	if( @ip1.display? )
		@ip1.draw(view)
		@drawn = true
	end
	
	if( @ip2.valid? )
		p1=@ip1.position
		p2=@ip2.position
		@ip2.draw(view) if( @ip2.display? )
		view.line_width=3
		view.set_color_from_line(p1, p2)
		view.draw_line(p1, p2)
		self.draw_geometry(p1, p2, view)
		@drawn = true
	end
end
end
#
def onCancel(flag, view)
    self.reset(view)
end
#
def reset(view)
    @state = 0
    Sketchup::set_status_text(get_status_text(), SB_PROMPT)
    @ip1.clear
    @ip2.clear
    
    if( view )
        view.tooltip = nil
        view.invalidate if @drawn
    end
    
	@a=nil
	@chain.clear
    @drawn = false
    @dragging = false
	@left_down=false
	@right_down=false
	@down_down=false
	@up_down=false
	view.lock_inference if view and view.inference_locked?
	if @operation_started
		Sketchup.active_model.commit_operation
		@operation_started=false
	end
end
##
def delete_fence(view)
if @a and @a.valid?
	@a.clear_existing_entities()
end
end
#
def place_fence(view,undo)
model = view.model
#model.start_operation("Build Assembly",true) if undo
entities = model.active_entities
pts=@chain.path
unless @a and (@a.valid?)
	@a=Assembly.add(entities)
	@a.fence=@fence
	@a.set_chain(Chain.new(pts))
	@a.draw()
else
	@a.set_chain(Chain.new(pts))
	@a.draw()
end
ProfileBuilder2.clear_pmpi()
#model.commit_operation if undo
end
###############################################
# Draw the temporary geometry
def draw_geometry(pt1, pt2, view)
vec=pt2-pt1
chain=Chain.new
chain.set_path(@chain.path)
chain.add(pt2)
		
if vec.length>0.0
	previewer=PMPreviewer.new(view)
	rails=@fence.rails
	rails.each {|rail|
		rail_profile=rail.profile
		next if rail_profile==nil
		next if rail_profile==""
		previewer.profile=rail.profile
		preview_path=chain.path
		temp_chain=Chain.new
		temp_chain.set_path(chain.path)
		previewer.chain=rail.offset_chain(temp_chain)
		previewer.draw(rail.start_setback,rail.junction_setback,rail.end_setback)
	}
	
	@fence.calc_posts_layout(chain.path)
	
	view.line_width=1
	previewer=ComponentPreviewer.new
	posts=@fence.posts
	posts.each {|post|
		next unless post.valid?
		instances=post.instances
		defn=post.component_definition
		previewer.definition=defn
		instances.each {|edge,transformations|
			if edge.last==chain.last
				transformations.each {|trans|
					previewer.transformation=trans
					previewer.draw(pt1,pt2)
				}
			end
		}
	}
	
end
end
end # class Tool
##
class PMPreviewer

def initialize(view=Sketchup.active_model.active_view)
@view=view
end
##
def profile=(p)
@profile=p
end
##
def chain=(c)
@chain=Chain.new
@chain.set_path(c.path)
end
##
def draw(start_setback,junction_setback,end_setback)
points=@profile.get_transformed_loop(@profile.points)
num_edges=@chain.get_edges().length
trans=@chain.transformation_at(num_edges-1)
points=points.collect {|p| p.transform(trans)}
base_offset_vec=@chain[-2].vector_to(@chain[-1])
return if base_offset_vec.length==0.0
end_setback_offset=base_offset_vec.reverse
end_setback_offset.length=end_setback
offset_vec=@chain[-2].vector_to(@chain[-1].offset(end_setback_offset))
return if !offset_vec.samedirection?(base_offset_vec)
extrude_length=offset_vec.length
if num_edges==1
	start_setback_offset=Geom::Vector3d.new(offset_vec)
	start_setback_offset.length=start_setback
	return if extrude_length<=(start_setback).abs
	points=points.collect {|p| p.offset(start_setback_offset)}
	offset_vec=offset_vec-start_setback_offset
end
end_points=points.collect {|p| p.offset(offset_vec)}
@view.line_width=1
draw_mode=@profile.is_2d? ? GL_LINE_LOOP : GL_LINE_STRIP
@view.draw(draw_mode, points)  #draw the profile at the first points
@view.draw(draw_mode, end_points)  #draw the profile at the end point
#now draw the lines connecting the start and end of the profile
points.each_index {|i| @view.draw(GL_LINES,[points[i],end_points[i]])}
#now draw the holes
holes=@profile.holes
holes.each {|hole|
	hole_pts=@profile.get_transformed_loop(hole)
	hole_pts=hole_pts.collect {|p| p.transform(trans)}
	if num_edges==1
		hole_pts=hole_pts.collect {|p| p.offset(start_setback_offset)}
	end
	hole_end_pts=hole_pts.collect {|p| p.offset(offset_vec)}
	
	@view.draw(GL_LINE_LOOP, hole_pts)
	@view.draw(GL_LINE_LOOP, hole_end_pts)
	hole_pts.each_index {|i| @view.draw(GL_LINES,[hole_pts[i],hole_end_pts[i]])}
}

end

end #class previewer
##
class ComponentPreviewer
@@cached_components={}
def initialize(view=Sketchup.active_model.active_view)
@view=view
end
##
def definition=(d)
@definition=d
@guid=@definition.guid
unless @@cached_components[@guid]
	cache_definition_edges(d,@guid)
end
end
##
def cache_definition_edges(defn,guid)
ents=defn.entities
edges=ents.grep(Sketchup::Edge)
groups=ents.grep(Sketchup::Group)
instances=ents.grep(Sketchup::ComponentInstance)
@@cached_components[guid]=[]
edges.each {|edge|
	@@cached_components[guid]<<[edge.start.position,edge.end.position]
}
groups.each {|group|
	trans=group.transformation
	ents=group.entities
	edges=ents.grep(Sketchup::Edge)
	edges.each {|edge|
		@@cached_components[guid]<<[edge.start.position.transform(trans),edge.end.position.transform(trans)]
	}
}
instances.each {|instance|
	trans=instance.transformation
	ents=instance.definition.entities
	edges=ents.grep(Sketchup::Edge)
	edges.each {|edge|
		@@cached_components[guid]<<[edge.start.position.transform(trans),edge.end.position.transform(trans)]
	}
}

end
##
def transformation=(t)
@trans=t
end
##
def draw(pt1,pt2)
draw_full()
end
##
def draw_full()
@@cached_components[@guid].each {|line|
	@view.draw_line(line.collect {|p| p.transform(@trans)})
}
end
##
def draw_bounds()
bb=@definition.bounds
bottom=[bb.corner(0),bb.corner(1),bb.corner(3),bb.corner(2)]
bottom=bottom.collect {|p| p.transform(@trans)}
top=[bb.corner(4),bb.corner(5),bb.corner(7),bb.corner(6)]
top=top.collect {|p| p.transform(@trans)}
@view.draw(GL_LINE_LOOP,bottom)
@view.draw(GL_LINE_LOOP,top)
bottom.each_index {|i| @view.draw_line(bottom[i],top[i])}
end

end #class previewer

end #module ProfileBuilder2

end #module DM
