require 'sketchup.rb'
module DM
module ProfileBuilder2
class SKPBrowser
include WebDialogHelper
def initialize(folder,title,&block)
folder.gsub!(/\\/,"\/")
@lib_folder=folder
@callback=block
@dlg=UI::WebDialog.new(title,true,"PB2Browser",950,950,400,100,true)
fn=File.join(PATH,"browse.html")
@dlg.set_file(fn)
color=@dlg.get_default_dialog_color
@dlg.set_background_color(color)
@num_loaded=0
@filter=""
@dlg.add_action_callback("refresh_dialog") {|d,p|
	refresh_dlg()
}
@dlg.add_action_callback("select_skp") {|d,p|
	p=File.join(@lib_folder,p+".skp")
	if FileTest.exist?(p)
		@callback.call(p)
	else
		UI.messagebox("文件未找到")
	end
}
@dlg.add_action_callback("search") {|d,p|
	@filter=p
	clear_results()
	load_thumbnails_from_folder(@lib_folder)
}
@dlg.add_action_callback("open_library") {|d,p|
	folder=UI.select_directory(
		title: "Open Library Folder",
		directory: File.dirname(@lib_folder)
	)
	@dlg.bring_to_front
	if folder
		@lib_folder=folder 
		@lib_folder.gsub!(/\\/,"\/")
		setValue("libDir",@lib_folder,@dlg)
		clear_results()
		load_thumbnails_from_folder(folder)
	end
}
@dlg.add_action_callback("load_more") {|d,p|
	load_more()
}
end
##
def show
if ON_MAC == true
	@dlg.show_modal{refresh_dlg()} unless @dlg.visible?
	@dlg.bring_to_front
else
	@dlg.show{refresh_dlg()} unless @dlg.visible?
end
end
##
def close
@dlg.close()
end
##
def clear_results()
@num_loaded=0
cmd="$('#results').empty();"
@dlg.execute_script(cmd)
end
##
def load_more()
load_thumbnails_from_folder(@lib_folder,@num_loaded)
end
#####
def load_thumbnails_from_folder(lib_dir,start_index=0,num_to_load=40)
skp_files=Dir.entries(lib_dir)
skp_files=skp_files.find_all {|f_name| f_name[-4..-1]==".skp"}
out=Sketchup.temp_dir
out=File.join(out,"pb_thumbs")
Dir.mkdir(out) if !FileTest.exist?(out)
if @filter!=""
	skp_files=skp_files.find_all {|p| File.basename(p,".skp")=~/#{@filter}/i}
end
count=0
end_index=start_index+(num_to_load-1)
skp_files=skp_files[start_index..end_index]
skp_files.sort!
skp_files.each {|file|
	
	name=File.basename(file,".skp")
	skp=File.join(lib_dir,file)
	thumbnail=File.join(out,name+".jpg")
	
	if true #!FileTest.exist?(thumbnail)
		status=Sketchup.save_thumbnail(skp,thumbnail)
		count+=1
	else
		skp_mod_time=File.mtime(skp)
		thumb_mod_time=File.mtime(thumbnail)
		if skp_mod_time>thumb_mod_time
			status=Sketchup.save_thumbnail(skp,thumbnail)
			count+=1
		end
	end
		
	thumbnail.gsub!(/\\/,"\/")
	cmd="listProfile('#{thumbnail}?#{(rand*10000).to_i}','#{name}');"
	@dlg.execute_script(cmd)
	@num_loaded+=1
}
end
def refresh_dlg()
clear_results()
setValue("libDir",@lib_folder,@dlg)
load_thumbnails_from_folder(@lib_folder)
end
end #class
end #module PB
end #module DM
