require 'sketchup.rb'
module DM
module ProfileBuilder2
class NoCapFaceException < RuntimeError
  attr :message
  def initialize()
    @message="Cannot Extend.  Profile Member must have an unmodified cap face."
  end
end
class ExtendTool
GETFIRSTPOINT=0
GETSECONDPOINT=2
include Geometry
def initialize
    @ip1 = nil
    @ip2 = nil
    @xdown = 0
    @ydown = 0
	@picked_cap_face=nil
	@picked_inst=nil
	@extend_vector=nil
	@extend_start=nil
	@thicken_face=nil
	@sel=Sketchup.active_model.selection
	@box=Sketchup.active_model.bounds
	@extended_face_points=Hash.new([])
	@original_face_points=Hash.new([])
	@new_edges=[]
	plugins = PATH
	icon = File.join(plugins, "cursors","extend_cursor.png")
	@cursor=UI.create_cursor(icon,1,1)
	icon = File.join(plugins, "cursors","extend_cursor_plus.png")
	@cursor_split=UI.create_cursor(icon,1,1)
	@ip1 = Sketchup::InputPoint.new
    @ip2 = Sketchup::InputPoint.new
    @ip = Sketchup::InputPoint.new
	@drawn = false
	@preselect=false
	@selected_capfaces={}
	@pm_instances=[]
	@split_member=false
	ro=Sketchup.active_model.rendering_options
	@highlight_color=ro["HighlightColor"]
	
end
def onSetCursor
if @split_member
	UI.set_cursor(@cursor_split) if @cursor_split
else
	UI.set_cursor(@cursor) if @cursor
end
end
####
def activate
    self.reset(nil)
end
##
def get_selected_profile_members()
@pm_instances=@sel.find_all {|e| Classify.profile_member?(e)}
@sel.clear
@sel.add(@pm_instances)
if @pm_instances.length>0
	@preselect=true
else
	@preselect=false
end
end
##
def deactivate(view)
    view.invalidate if @drawn
end
##
def set_status_text()
case @state
when GETFIRSTPOINT
	Sketchup::set_status_text("点击轮廓放样模型的端点或点击一个面生成轮廓放样模型")
when GETSECONDPOINT
	Sketchup::set_status_text("点击第二个点或者输入数值. 按下Ctrl键复制.")
end
end
##
def getExtents
return @box
end
####
def onMouseMove(flags, x, y, view)
	
    if( @state == GETFIRSTPOINT)
        
		@picked_inst=get_profile_member_below_cursor(x,y,view)
		@thicken_face=get_face_below_cursor(x,y,view) if !@preselect
		
        @ip.pick view, x, y
        if( @ip != @ip1 )
           
            @ip1.copy! @ip
			
			if !@preselect
				@sel.clear
				select_profile_member_below_cursor()
				select_face_below_cursor()
			end
        end
		get_cap_face_below_cursor(view,x,y) if @picked_inst
		view.invalidate 
    else
		if @extending
			@ip.pick view, x, y
			if (@ip!=@ip2)
				if ((@pm_instances.length>0) or (@thicken_face))
					@ip2.copy! @ip
					self.update_extension(x,y,view)
					@x=x  #store x and y position
					@y=y
					view.invalidate
					
				else
					self.reset(nil)
				end
			end       
	       
	        if( @ip2.valid? )
	            length = self.extension_length
	            Sketchup::set_status_text(Sketchup.format_length(length), SB_VCB_VALUE)
	        end
        else
	        if( (x-@xdown).abs > 10 || (y-@ydown).abs > 10 )
	            @dragging = true
				if @pm_instances.length>0 and @picked_inst
					self.start_extend()
					@extending=true
				elsif @thicken_face
					self.start_thicken()
					@extending=true
				end
		
	        end
		end
    end
end
##
def get_profile_member_below_cursor(x,y,view)
inst=get_inst_below_cursor(view,x,y)
status=nil
if Classify.profile_member?(inst)
	pm=ProfileMember.new(inst)
	unless pm.revolved? or pm.closed_path?
		status=inst
	end
	if @preselect
		status=nil unless @pm_instances.include?(inst)
	end
end
return status
end
##
def get_face_below_cursor(x,y,view)
ph=view.pick_helper
ph.do_pick(x,y)
ent=ph.best_picked
if ent.class==Sketchup::Face
	return ent
end
return nil
end
##
def select_profile_member_below_cursor()
@pm_instances.clear
if @picked_inst
	@pm_instances.push(@picked_inst)
	@sel.add(@picked_inst)
end
end
##
def select_face_below_cursor()
if @thicken_face
	@sel.add(@thicken_face)
end
end
#
def onKeyDown(key, repeat, flags, view)
		
    if( key == COPY_MODIFIER_KEY)
		@split_member=!@split_member
	end   
end
###
def onLButtonDown(flags, x, y, view)
   
if( @state == GETFIRSTPOINT)
	if ((@pm_instances.length>0 and @picked_inst) or (@thicken_face))
		if @picked_inst
			@thicken_face=nil
			pickray=view.pickray(x,y)
			pm_picked=ProfileMember.new(@picked_inst)
			@cap_index=pm_picked.get_picked_cap_face_index(pickray)
			cap_faces=pm_picked.get_cap_vertices()
			@picked_cap_face=cap_faces[@cap_index]
			if @picked_cap_face==nil
				UI.messagebox("选择的端点已经被修改，不能延伸！")
				self.reset(view)
				return
			end
			@extend_start=@cap_index==0 ? true : false
			box=Geom::BoundingBox.new
			box.add(@picked_cap_face.collect {|v| v.position})
			@picked_face_center=box.center.transform(@picked_inst.transformation)
		end
		@ip1=Sketchup::InputPoint.new(@picked_face_center)
		@state = GETSECONDPOINT
		@xdown = x
		@ydown = y
		set_status_text()
	end
else
	# commit the extension
	if( @ip2.valid? )
		self.commit_extension()
		self.reset(view)
	end
end
view.invalidate
end
####
def onLButtonUp(flags, x, y, view)
  
    if( @dragging && @ip2.valid? )
        self.commit_extension()
        self.reset(view)
    end
end
##
def onUserText(text, view)
    
    return if not @state == GETSECONDPOINT
    return if not @extending    
    
    begin
        value = text.to_l
    rescue
        # Error parsing the text
        UI.beep
        puts "Cannot convert #{text} to a Length"
        value = nil
        Sketchup::set_status_text "", SB_VCB_VALUE
    end
    return if !value
	if( value.to_f<0.01 )
        UI.beep
        return
    end
  
	if @extend_vector and @extend_vector.length>0.0
		@extend_vector.length=value.to_f
	end
    self.commit_extension()
    self.reset(view)
end
##
def draw(view)
    if( @ip1.valid? )
        if( @ip1.display? )
			if @picked_inst and @picked_cap_face and @picked_inst.valid?
				draw_picked_face(view,@picked_cap_face,@picked_inst.transformation,@is_polyline)
			end
            @drawn = true
        end
        
        if @state==GETSECONDPOINT
            @ip2.draw(view) if( @ip2.display? )
            self.draw_geometry(@ip1.position, @ip2.position, view)
			if @picked_inst and @picked_cap_face and @picked_inst.valid?
				draw_picked_face(view,@picked_cap_face,@picked_inst.transformation,@is_polyline)
			end
			@drawn = true
        end
    end
end
####
def onCancel(flag, view)
	@sel.clear
	@preselect=false
    self.reset(view)
end
##
def resume(view)
set_status_text()
end
####
def reset(view)
    
    @state = 0
	@extending=false
    Sketchup::set_status_text(@status_text)
    @ip1.clear
    @ip2.clear
    @extended_face_points.clear
	@original_face_points.clear
	@selected_capfaces.clear
	@pm_instances.clear
	@extend_vector=nil
    if( view )
        view.tooltip = nil
        view.invalidate if @drawn
    end
	@picked_cap_face=nil
	@picked_inst=nil
	@picked_face_trans=nil
    @drawn = false
    @dragging = false
	@extend_start=nil
	@thicken_face=nil
	@split_member=false
	get_selected_profile_members()
	set_status_text()
end
####
def draw_geometry(pt1, pt2, view)
  
   view.drawing_color="black"
   view.line_stipple=""
   if @extended_face_points.length>0
		@extended_face_points.each {|inst,face_pts|
			mode=GL_LINE_LOOP
			if @thicken_face
				f=@thicken_face
				original_face_pts=f.outer_loop.vertices.collect {|v| v.position}
			else
				f=@selected_capfaces[inst]
				pm=ProfileMember.new(inst)
				mode=GL_LINE_STRIP if pm.profile.is_1d?
				trans=pm.transformation
				original_face_pts=f.collect {|v| v.position.transform(trans)}
			end
			@box.add(face_pts)
			view.draw(mode,face_pts)
			original_face_pts.each_index {|i| view.draw_line(original_face_pts[i],face_pts[i])}
			#debug
			#if @picked_cap_face
			#	view.drawing_color="red"
			#	face_pts=@picked_cap_face.collect {|v| v.position.transform(trans)}
			#	view.draw(GL_LINE_LOOP,face_pts)
			#end
		}
		if @ip1.valid? and @extend_vector
			view.line_stipple="-"
			pt=@picked_face_center.offset(@extend_vector)
			view.draw_line(@ip1.position,@ip1.position.offset(@extend_vector))
			view.draw_line(pt,@ip.position)
		end
	end
end

###
def start_extend()
begin
	Sketchup.active_model.start_operation("Extend",true)
	select_cap_faces_of_selected_profile_memberes()
	get_extended_face_points()
	
rescue NoCapFaceException => error
	UI.messagebox(error.message)
	Sketchup.active_model.abort_operation
	raise
end
end
##
def start_thicken()
begin
	Sketchup.active_model.start_operation("Extend",true)
	face_pts=@thicken_face.outer_loop.vertices.collect {|v| v.position}
	@extended_face_points[@thicken_face]=face_pts
	@original_face_points[@thicken_face]=face_pts.dup
	box=Geom::BoundingBox.new
	box.add(face_pts)
	@picked_face_center=box.center
	@ip1=Sketchup::InputPoint.new(@picked_face_center)
rescue 
	raise
end
end
##
def get_picked_face_old()
if @picked_inst
	pm=ProfileMember.new(@picked_inst)
	trans=@picked_inst.transformation
	cap_faces=pm.get_cap_vertices()
	raise NoCapFaceException if ((cap_faces.first==nil) and (cap_faces.last==nil))
	cap_faces.delete(nil)
	closest_face=get_closest_face_to_input_point(cap_faces,trans)
	index=cap_faces.index(closest_face)
	@extend_start=index==0 ? true : false
	box=Geom::BoundingBox.new
	box.add(closest_face.collect {|v| v.position})
	@picked_face_center=box.center.transform(trans)
	@ip1=Sketchup::InputPoint.new(@picked_face_center)
	return closest_face
end
return nil
	
end
##
def select_cap_faces_of_selected_profile_memberes()
@pm_instances.each {|inst| inst.make_unique if inst.class==Sketchup::Group}
##prevent duplicate extensions of component definitions
if @picked_inst.class==Sketchup::ComponentInstance
	#@pm_instances.delete_if {|inst| inst.definition==@picked_inst.definition}
	#@pm_instances.push(@picked_inst)
else
	pm_picked=ProfileMember.new(@picked_inst)
	cap_faces=pm_picked.get_cap_vertices()
	@picked_cap_face=cap_faces[@cap_index]
end
@pm_instances.each {|inst|
	pm=ProfileMember.new(inst)
	trans=inst.transformation
	origin=trans.origin
	selected_cap_face=pm.get_cap_vertices()[@cap_index]
	next if selected_cap_face==nil
	@selected_capfaces[inst]=selected_cap_face
}
end
##
def get_closest_face_to_input_point(faces,trans)
cursor_point=@ip.position
distance_to_ip=[]
faces.each_index {|index|
	verts=faces[index]
	box=Geom::BoundingBox.new
	face_pts=verts.collect {|v| v.position.transform(trans)}
	box.add(face_pts)
	face_center=box.center
	distance_to_ip.push(face_center.vector_to(cursor_point).length)
}
min_distance=distance_to_ip.min
min_index=distance_to_ip.index(min_distance)
return faces[min_index]
end
##
def get_cap_face_below_cursor(view,x,y)
@cap_index=nil
@picked_cap_face=nil
pickray=view.pickray(x,y)
pm_first=ProfileMember.new(@picked_inst)
@cap_index=pm_first.get_picked_cap_face_index(pickray)
cap_faces=pm_first.get_cap_vertices()
@picked_cap_face=cap_faces[@cap_index]
if pm_first.profile.is_1d?
	@is_polyline=true
else
	@is_polyline=false
end
unless @picked_cap_face
	@cap_index=nil
	@is_polyline=false
end
end
##
def get_extended_face_points()
@selected_capfaces.each {|inst,f|
	trans=inst.transformation
	face_pts=f.collect {|v| v.position.transform(trans)}
	@extended_face_points[inst]=face_pts
	@original_face_points[inst]=face_pts.dup
}
end
##
def update_extension(x,y,view)
if @thicken_face
	do_update_thicken(x,y,view)
else
	do_update_extension(x,y,view)
end
end
##
def do_update_thicken(x,y,view)
if @ip2.valid?
	
	f_normal=@thicken_face.normal
	
	ip_vertex=@ip.vertex
	ip_edge=@ip.edge
	ip_face=@ip.face
	
	p1=@ip1.position
	ray=view.pickray(x,y)
	line1=ray
	line2=[p1,f_normal]
	p2=Geom.closest_points(line1, line2)[1]
	vec=p1.vector_to(p2)
	
	if ip_vertex or ip_edge or ip_face
		ip_vertex_pos=@ip.position
		p1=@extended_face_points[@thicken_face][0]  #get the current position of the extruded face
		p2=@original_face_points[@thicken_face][0]  #get the original position of the extruded face
		vec1=p2.vector_to(ip_vertex_pos) 
		len=vec1.dot(f_normal)
		vec=f_normal.clone
		vec.length=len
	end
	
	distance=vec.length
	@extend_vector=vec
	extend_distance=self.extension_length
	
	
	@original_face_points.each {|f,face_pts|
	
		vec=f.normal
		vec.length=extend_distance
		f_verts=f.vertices
		ents=f.parent.entities
		trans=Geom::Transformation.translation(vec)
		new_face_pts=face_pts.collect {|p| p.transform(trans)}
		@extended_face_points[f]=new_face_pts
	}
		
end
end
#####
def do_update_extension(x,y,view)
if @ip2.valid? and @picked_cap_face
	pm=ProfileMember.new(@picked_inst)
	f_normal=pm.start_extend_vector() if @cap_index==0
	f_normal=pm.end_extend_vector() if @cap_index==1
	f_normal.transform!(pm.transformation)
	
	ip_vertex=@ip.vertex
	ip_edge=@ip.edge
	ip_face=@ip.face
	
	p1=@ip1.position
	ray=view.pickray(x,y)
	line1=ray
	line2=[p1,f_normal]
	p2=Geom.closest_points(line1, line2)[1]
	vec=p1.vector_to(p2)
	
	ip_vertex_pos=@ip2.position
	p1=@extended_face_points[@picked_inst][0]  #get the current position of the extruded face
	p2=@original_face_points[@picked_inst][0]  #get the original position of the extruded face
	vec1=p2.vector_to(ip_vertex_pos) 
	len=vec1.dot(f_normal)
	vec=f_normal.clone
	vec.length=len
	
	@extend_vector=vec
	extend_distance=self.extension_length
	
	@original_face_points.each {|inst,face_pts|
		f=@selected_capfaces[inst]
		pm=ProfileMember.new(inst)
		vec=get_extend_vector(pm)
		extend_distance=validate_extend_distance(f,extend_distance)
		vec.length=extend_distance
		trans=Geom::Transformation.translation(vec)
		new_face_pts=face_pts.collect {|p| p.transform(trans)}
		@extended_face_points[inst]=new_face_pts
	}
		
end
end
##
def get_extend_vector(pm)
if @cap_index==0
	vec=pm.start_extend_vector()
else
	vec=pm.end_extend_vector()
end
return vec.transform(pm.transformation)
end
##
def validate_extend_distance(verts,extend_distance)
dist=extend_distance
min_perp_edge_length=get_min_perp_edge_length(verts)
if min_perp_edge_length and (extend_distance<0.0)
	dist=[extend_distance,-min_perp_edge_length].max
	dist+=0.005
else
	dist=extend_distance
end
return dist
end

####
def commit_extension()
extension_length=self.extension_length
if @thicken_face
	thicken_face_to_profile_member()
else
	defns=[]
	@selected_capfaces.each {|inst,face|
		next if defns.include?(inst.definition)
		pm=ProfileMember.new(inst)
		dist=validate_extend_distance(face,extension_length)
		if @cap_index==0
			pm.extend_start(dist,@split_member)
		else
			pm.extend_end(dist,@split_member)
		end
		defns.push(inst.definition)
	}
end
if !@preselect
	@sel.clear
end
	
Sketchup.active_model.commit_operation
end
##
def thicken_face_to_profile_member()

name=UI.inputbox(["名称"],["New Profile"],"创建新的轮廓放样模型")
return if not name

ents=Sketchup.active_model.active_entities
box=Geom::BoundingBox.new
box.add(@original_face_points[@thicken_face])
box_center=box.center
chain=[box_center,box_center.offset(@extend_vector)]
pm=ProfileMember.add(ents,chain)
profile=Profile.new(@thicken_face)
profile.name=name[0]
group=ents.add_group([@thicken_face])
ents.erase_entities([group])
pm.profile=profile
pm.draw()
end
###
def extension_length()
if @extend_vector and @extend_vector.length>0.0
	if @thicken_face
		f_normal=@thicken_face.normal
	else
		inst=@selected_capfaces.key(@picked_cap_face)
		pm=ProfileMember.new(inst)
		f_normal=get_extend_vector(pm)
	end
	unless @extend_vector.samedirection?(f_normal)
		return -(@extend_vector.length)
	else
		return @extend_vector.length
	end
else
	return 0.0
end
end
end #class
end #module
end #module DM
