########
module DM
module ProfileBuilder2
SELECTED_EDGE_COLOR="blue"
START_EDGE_COLOR="green"
END_EDGE_COLOR="red"
CANDIDATE_COLOR="orange"
class PathEditTool
def initialize(chain)
@chain=chain
end
##
def resume(view)
view.invalidate
end
##
def onLButtonDown(flags, x, y, view)
onRButtonDown(flags, x, y, view)
tools=Sketchup.active_model.tools
tools.pop_tool()
Sketchup.active_model.select_tool(tools.pop_tool())
end
###
def draw(view)
@chain.draw(view)
end
end

###
class PathSelectTool
@@chain=nil
def PathSelectTool.get_selected_path()
sel=Sketchup.active_model.selection
if sel.single_object?
	e=sel.first
	if Classify.profile_member?(e)
		pm=ProfileMember.new(e)
		path=pm.chain
		path=path.collect {|p| p.transform(pm.transformation)}
		return path
	elsif Classify.assembly?(e)
		a=Assembly.get(e)
		path=a.chain
		path=path.collect {|p| p.transform(a.transformation)}
		return path
	elsif e.class==Sketchup::Face
		edges=e.edges
	elsif e.class==Sketchup::Edge
		edges=sel.grep(Sketchup::Edge)
	end
else
	edges=sel.grep(Sketchup::Edge)
end
pts_chain=Chain.new
status=pts_chain.set(edges)
return nil if not status  #current selection is not a valid path
	
if @@chain  
	vertex_chain_pts=@@chain.points
	selected_edges_pts=pts_chain.path
	if (vertex_chain_pts==selected_edges_pts) or (vertex_chain_pts==selected_edges_pts.reverse)
		return vertex_chain_pts
	else
		return selected_edges_pts
	end
else	
	return pts_chain.path
end
return nil
end
##
def initialize
@state0_status_text="点击一个边线添加到选择中，点击回车或者空格键结束选择，点击ESC键清除选择，双击选择连续线。"
@model=Sketchup.active_model
@ph=@model.active_view.pick_helper
@@chain=VertexChain.new
@sel=@model.selection
@sel.clear
@last_click_time=Time.now
plugins=PATH
icon = File.join(plugins,"cursors/path_select_cursor.png")
@icon=UI.create_cursor(icon,1,1)
@marker_size=40
end

def activate
    self.reset(nil)
end
def deactivate(view)
	@sel.clear
	if @@chain.edges and @@chain.edges.length>0
		@sel.add(@@chain.edges)
	end
end
###
def onSetCursor
UI.set_cursor(@icon)
end
###
def onReturn(view)
Sketchup.active_model.select_tool(nil)
return
if @@chain.points.length>2
	Sketchup.break_edges=false
	weld(@@chain.points)
	Sketchup.break_edges=true
	#Sketchup.active_model.select_tool(nil)
end
end
###
def weld(pts)
Sketchup.active_model.start_operation("Weld Edges")
ents=Sketchup.active_model.active_entities
#t_group=ents.add_group
#g_ents=t_group.entities
#g_ents.add_curve(pts)
ents.add_curve(pts)
#t_group.explode
Sketchup.active_model.commit_operation
end
####
def onMouseMove(flags, x, y, view)
	
	@ph.do_pick(x,y)
	best=@ph.best_picked
	if best.class==Sketchup::Edge
		@hover_edge=best
		@start_vert=get_picked_vertex(x,y,view)
		unless @hover_edge.parent.entities==@model.active_entities
			@hover_edge=nil
		end
		if @@chain.edges() and @@chain.edges().include?(@hover_edge)
			@hover_edge=nil
		end
	end
	view.invalidate
end
def onUserText(text, view)
  
  
    # The user may type in something that we can't parse as a length
    # so we set up some exception handling to trap that
    begin
        value = text.to_l
    rescue
        # Error parsing the text
        UI.beep
        puts "Cannot convert #{text} to a Length"
        value = nil
        Sketchup::set_status_text "", SB_VCB_VALUE
    end
    return if !value
	offset_path(value)
   
end

def offset_path(dist)
Sketchup.active_model.start_operation("Offset Path")
new_chain=Chain.new(@@chain.points)
new_chain.offset!(dist,0)
pts=new_chain.path
ents=Sketchup.active_model.active_entities
ents.add_edges(pts)
Sketchup.active_model.commit_operation

end
#
def get_picked_vertex(x,y,view)
vert=nil
if @hover_edge
	ray=view.pickray(x,y)
	v1=@hover_edge.start
	v2=@hover_edge.end
	verts=[v1,v2]
	eye=ray[0]
	vec_cursor=ray[1]
	vec1=eye.vector_to(v1.position)
	vec2=eye.vector_to(v2.position)
	angle1=vec_cursor.angle_between(vec1)
	angle2=vec_cursor.angle_between(vec2)
	angles=[angle1,angle2]
	min_angle=angles.min
	index=angles.index(min_angle)
	vert=verts[index]
end
return vert
end
###
def onLButtonDown(flags, x, y, view)
	
	#first check that user is hovering over an edge
	if @hover_edge!=nil
		@picked_edge=@hover_edge
				
		#if nothing has been added to the chain
		if @@chain.length==0
			@@chain.add(@picked_edge,@start_vert)
			@sel.add(@picked_edge)
		else
			path=@@chain.get_path(@picked_edge)
			if path
				@@chain.add(@picked_edge)
				path[1].each {|e| @sel.add(e)}
				@sel.add(@@chain.edges)
			end
		end
	end
	view.invalidate
end
####
 def onLButtonDoubleClick(flags, x, y, view)
if @picked_edge.class==Sketchup::Edge
	@sel.clear
	@@chain.clear
	@@chain.add_smartpath(@picked_edge,@picked_edge.other_vertex(@start_vert))
	@@chain.edges.each {|e| @sel.add(e)}
	view.invalidate
	@sel.add(@@chain.edges)
end
end
###
def resume(view)
view.invalidate
end
def draw(view)
point_size=6
point_style=2
view.line_width=6
@@chain.validate()
if @hover_edge and @hover_edge.valid?
	
	if @@chain.length>0
		draw_path_candidate_edges(view) unless @hover_edge==@@chain.edges[0]
	end
	
	if @@chain.length==0
		pts=[@start_vert.position,@hover_edge.other_vertex(@start_vert).position]
		temp_chain=Chain.new(pts)
		temp_chain.draw(view)
	end
end
if @@chain.length>0
	temp_chain=Chain.new(@@chain.points)
	temp_chain.draw(view)
end
end
##
def draw_path_candidate_edges(view)
view.drawing_color=CANDIDATE_COLOR
view.line_width=6
verts=@hover_edge.vertices
view.draw_line(verts[0].position,verts[1].position)
path=@@chain.get_path(@hover_edge)
if path
	path_edges=path[1]
	path_vertices=path[0]
	path_edges.each {|e| view.draw_line(e.start.position,e.end.position)}
end
end
##
def onCancel(flag, view)
    self.reset(view)
	view.invalidate
end
###
def reset(view)
    @@chain=VertexChain.new
	@@path=nil
	@sel.clear
    # Display a prompt on the status bar
    Sketchup::set_status_text(@state0_status_text, SB_PROMPT)
 
    if( view )
        view.invalidate if @drawn
    end
    
end
def resume(view)
Sketchup::set_status_text(@state0_status_text, SB_PROMPT)
end
end #class
#####
class VertexChain
def initialize
@ents=nil
@chain_vertices=[]
end
###
def validate()
@chain_vertices.delete_if {|v| !v.valid?}
edges=self.edges()
if edges
	
	vert_length=(edges.length)+1
	@chain_vertices=@chain_vertices[0..vert_length]
else
	self.clear
end
end
#
def loop?
if @chain_vertices.length>2
	if @chain_vertices.last.common_edge(@chain_vertices.first)
		return true
	end
end
return false
end
###
def clear
@chain_vertices=[]
end
##
def edges()
chain_edges=[]
return nil if @chain_vertices.length<2
@chain_vertices.delete_if {|v| !v.valid?}
(self.length-1).times {|i|
	chain_edges.push(@chain_vertices[i].common_edge(@chain_vertices[i+1]))
}
nil_index=chain_edges.index(nil)
if nil_index
	chain_edges=chain_edges[0..(nil_index-1)]
	@chain_vertices=@chain_vertices[0..nil_index]
end
if nil_index==0
	chain_edges=[]
	self.clear
end
return chain_edges
end
##
def add(edge,start_vertex=nil) 
if @chain_vertices.empty?
	if start_vertex
		@chain_vertices<<start_vertex<<edge.other_vertex(start_vertex)
	else
		@chain_vertices.concat(edge.vertices)
	end
	return
end
s_edge=self.start_edge
if self.length==2 #special case where we don't know the direction of the chain yet
	current_vert=nil
else
	current_vert=self.end_vert
end
path=find_path(s_edge,edge,@chain_vertices,current_vert)
if path
	new_verts=path[0]
	#check if we have to swap the first two vertices based on the path that was found
	if self.length==2
		unless new_verts[0].common_edge(@chain_vertices[1])
			temp=@chain_vertices[0]
			@chain_vertices[0]=@chain_vertices[1]
			@chain_vertices[1]=temp
		end
	end
	@chain_vertices.concat(path[0])
	
end
end
###
def length
return @chain_vertices.length
	
end
###
def start_vert
if @chain_vertices.length>0
	return @chain_vertices[0]
end
end
###
def end_vert
if @chain_vertices.length>0
	return @chain_vertices[-1]
end
end
####
def end_edge
if @chain_vertices.length>=2
	return @chain_vertices[-1].common_edge(@chain_vertices[-2])
else
	return nil
end
end
#####
def start_edge
if @chain_vertices.length>=2
	return @chain_vertices[0].common_edge(@chain_vertices[1])
else
	return nil
end
end
def get_path(edge)
return nil if self.start_edge==nil
if self.length==2 #special case where we don't know the direction of the chain yet
	current_vert=nil
else
	current_vert=self.end_vert
end
path=find_path(self.start_edge,edge,@chain_vertices,current_vert)
return path
end
###
def add_smartpath(edge,e_vert=nil)
#we must have an empty chain to use this function
unless @chain_vertices.empty?
	return
end
s_edge=edge
if e_vert
	s_vert=s_edge.other_vertex(e_vert)
else
	s_vert=s_edge.start
	e_vert=s_edge.end
end
@chain_vertices.push(s_vert)
@chain_vertices.push(e_vert)
path=find_smartpath(s_edge,[s_vert],e_vert)
if path
	new_verts=path[0]
	@chain_vertices.concat(new_verts)
end

#if we haven't found a closed loop, try to find a path in the other direction as well
unless self.loop?
	path2=find_smartpath(s_edge,@chain_vertices,s_vert)
	if path2
		new_verts=path2[0]
		if self.length>2 #occurs if path was added above
			new_verts.reverse!
			@chain_vertices=new_verts+@chain_vertices
		elsif self.length==2 #no path was added above so swap the first two vertices so
			temp=@chain_vertices[0]
			@chain_vertices[0]=@chain_vertices[1]
			@chain_vertices[1]=temp
			@chain_vertices.concat(new_verts)
		end
	end
end #unless
end
####
def start
return @chain_vertices[0]
end
###
def end
return @chain_vertices.last
end
###
def end_edge
return nil unless @chain_vertices.length>1
return @chain_vertices.last.common_edge(@chain_vertices[-2])
end
###
def points
return @chain_vertices.collect {|v| v.position}
end
private
	###returns the path edges between the start and end edges
	def find_smartpath(s_edge,avoid_vertices=[],current_vert=nil)
	avoid=avoid_vertices.dup
	path_verts=[]
	path_edges=[]
	middle_edges=[]  #the edges that are between the current end of the chain and the new edge
	middle_vertices=[]  #the vertices that are between the start and end edges
	next_vert=nil
	next_edge=nil
	count=0
	angle=0
	
	if current_vert==nil
		current_vert=s_edge.end
	end
	
	#path_verts.push(current_vert)
	s_vert=s_edge.other_vertex(current_vert)
	s_vec=s_vert.position.vector_to(current_vert.position)
	
	target_vec=s_vec
	#now crawl along the vertices to find the path
	while (current_vert!=nil)
		pot_edges=current_vert.edges
		pot_edges.delete_if {|e| avoid.include?(e.other_vertex(current_vert))}
		avoid.delete(s_vert) if count==0
		num_pot_edges=pot_edges.length
		if num_pot_edges>1
			next_edge=get_edge_closest_to_vector(target_vec,pot_edges,current_vert)
			next_vert=next_edge.other_vertex(current_vert) if next_edge
			next_vert=nil unless next_edge
		elsif num_pot_edges==1
			next_edge=pot_edges[0]
			next_vert=next_edge.other_vertex(current_vert)
		else
			next_vert=nil
		end
		
		if next_vert
			avoid.push(current_vert)
			path_verts.push(next_vert)
			target_vec=current_vert.position.vector_to(next_vert.position)
			middle_edges.push(next_edge)
			next_vert=nil if next_vert.used_by?(s_edge)  #we found a closed loop so exit the loop
		end
		current_vert=next_vert
		count+=1
		break if count==500
	end #while
	if path_verts.length>0 #i.e. we found a path using the above loop
		return [path_verts,middle_edges]
	else
		return nil
	end
	end
	
	###
	def get_edge_closest_to_vector(vec,edges,vert)
	
	angle_threshold=(Math::PI/2.0)
	edge_angles=edges.collect {|edge|
		p0=vert.position
		p1=edge.other_vertex(vert).position
		edge_vec=p0.vector_to(p1)
		vec.angle_between(edge_vec)
	}
	
	min_angle=edge_angles.min
	if min_angle>=angle_threshold
		picked_edge=nil
	else
		index=edge_angles.index(min_angle)
		picked_edge=edges[index]
	end
	
	return picked_edge
		
	end
	###returns the path edges between the start and end edges
	def find_path(s_edge,e_edge,avoid_vertices=[],current_vert=nil)
	avoid=avoid_vertices.dup
	path_verts=[]
	path_edges=[]
	middle_edges=[]  #the edges that are between the current end of the chain and the new edge
	middle_vertices=[]  #the vertices that are between the start and end edges
	return nil if s_edge.parent.entities!=e_edge.parent.entities
	return nil unless s_edge.all_connected.include?(e_edge)
	s_vec=s_edge.end.position-s_edge.start.position  
	e_edge_midpoint=Geom.linear_combination(0.5,e_edge.start.position, 0.5, e_edge.end.position)
	#find the vertex on the start edge that is closest to the midpoint of the end edge
	if current_vert==nil
		distance_to_verts=[(e_edge_midpoint-s_edge.start.position).length,(e_edge_midpoint-s_edge.end.position).length]
		min_dist=distance_to_verts.min
		if distance_to_verts.index(min_dist)==0
			current_vert=s_edge.start
		else
			current_vert=s_edge.end
		end
	end
	#find the vertex on the end edge that is closet to the start 
	distance_to_verts=[(current_vert.position-e_edge.start.position).length,(current_vert.position-e_edge.end.position).length]
	min_dist=distance_to_verts.min
	if distance_to_verts.index(min_dist)==0
		target_vert=e_edge.start
	else
		target_vert=e_edge.end
	end
	next_vert=nil
	next_edge=nil
	target_vec=target_vert.position-current_vert.position
	count=0
	#now crawl along the vertices to find the path to the target vert
	while ((current_vert!=nil) and (current_vert!=target_vert))
		current_edges=current_vert.edges
		current_edges.delete_if {|e| avoid.include?(e.other_vertex(current_vert))}
		angle=Math::PI
		current_edges.each {|e|
			edge_vec=e.other_vertex(current_vert).position-current_vert.position
			target_angle=edge_vec.angle_between(target_vec)
			if s_edge.faces.length==1 and e_edge.faces.length==1
				if e.faces.length==1
					angle=target_angle
					next_vert=e.other_vertex(current_vert)
					next_edge=e
					break
				end
			end
			if target_angle<=angle
				angle=target_angle
				next_vert=e.other_vertex(current_vert)
				next_edge=e
			end
		}
		if next_vert
			next_vert=nil if next_vert==current_vert  #no path was found
		end
		if next_vert
			avoid.push(next_vert)
			path_verts.push(next_vert)
			current_vert=next_vert
			target_vec=target_vert.position-current_vert.position
			middle_edges.push(next_edge)
		end
		
		count+=1
		break if count==100
	end #while
	if current_vert==target_vert #i.e. we found a path using the above loop
		vert=e_edge.other_vertex(target_vert)
		path_verts.push(vert) unless path_verts.include?(vert)
		return [path_verts,middle_edges]
	else
		return nil
	end
	end
	
end #class

###
class Chain
include Enumerable
include Geometry
def initialize(pts=nil)
raise ArgumentError,"points array not passed to chain initializer",caller unless (pts.is_a?(Array) or pts.nil?)
@path=pts if pts
@edge_trans_array=[]
@point_trans_array=[]
end
##
def index(pt)
return @path.index(pt)
end
##
def length
return @path.length
end
##
def closest_point_on_path(pickray,trans=Geom::Transformation.new)
	
edges=self.edges
distances=[]
closest_point_on_edges=edges.collect {|edge|
	line=edge
	line=line.collect {|p| p.transform(trans)}
	closest_pts=Geom.closest_points(pickray,line)
	p0=closest_pts[0]
	p1=closest_pts[1]
	line_vec=line[0].vector_to(line[1])
	p_vec=line[0].vector_to(p1)
	if (line_vec.samedirection?(p_vec)) and (line_vec.length<=p_vec.length)
		p1.set!(line[1])
	elsif (!line_vec.samedirection?(p_vec))
		p1.set!(line[0])
	end
	#distances.push(p0.distance(p1))
	p1
}
distances=closest_point_on_edges.collect {|p| p.distance_to_line(pickray)}
min_distance=distances.min
index=distances.index(min_distance)
closest_point=closest_point_on_edges[index]
return closest_point, index
end
##
def distance_along_path(point,trans=Geom::Transformation.new)
	
edges=self.edges
running_length=0.0
point_on_path=false
edges.each {|edge|
	edge=edge.collect {|p| p.transform(trans)}
	dist=point_on_edge(point,edge)
	if !dist
		edge_vec=edge[0].vector_to(edge[1])
		running_length+=edge_vec.length
	else
		point_on_path=true
		running_length+=dist
		break
	end
}
if point_on_path
	return running_length
else
	return nil
end
	
end
##
def chain_length(trans=Geom::Transformation.new)
running_length=0.0
(@path.length-1).times {|i|
	p1=@path[i].transform(trans)
	p2=@path[i+1].transform(trans)
	vec=p1.vector_to(p2)
	running_length+=vec.length
}
return running_length
end
##
def point_at_distance(distance,trans=Geom::Transformation.new)
edges=self.edges
running_length=0.0
edge_length=0.0
edge_vec=nil
delta=0.0
edges.each {|edge|
	edge=edge.collect {|p| p.transform(trans)}
	edge_vec=edge[0].vector_to(edge[1])
	edge_length=edge_vec.length
	running_length+=edge_length
	delta=running_length-distance
	break if running_length>distance
}
edge_vec.length=(edge_length-delta)
pt=edge[0].offset(edge_vec)
return pt
end
##
def edges
num_edges=self.num_points-1
e=[]
num_edges.times {|i|
	p0=Geom::Point3d.new(@path[i])
	p1=Geom::Point3d.new(@path[i+1])
	e.push([p0,p1])
}
return e
end
def each
@path.each {|p| yield(p)}
end
def num_points
return @path.length
end
def closed_path?
return @path.first==@path.last
end
def set_path(pts_array)
@path=pts_array.dup
end
def path
return @path.dup
end
def clear
@path=[]
end
def get_edges()
edges=[]
num_pts=@path.length
(num_pts-1).times {|i|
	edges.push([@path[i],@path[i+1]])
}
return edges
end
#
def transformation_at(edge_index)
calc_trans_array()
return @edge_trans_array[edge_index]
end
##
def point_transformation_at(point_index)

return @point_trans_array[point_index]
end
#
def angle_at(pt_index)
return nil if pt_index==0
return nil if pt_index==(@path.length-1)
prev_vec=@path[pt_index-1].vector_to(@path[pt_index])
next_vec=@path[pt_index].vector_to(@path[pt_index+1])
return prev_vec.angle_between(next_vec)
end
#set the path based on an array of edges - edges should form a continuous chain 
def set(edges,first_vertex=nil)
@path=[] if edges.length==0
all_verts=edges.collect {|e| e.vertices}
all_verts.flatten!
num_verts=Hash.new(0)
all_verts.each {|v| num_verts[v]+=1}
#find the end points of the path and validate the path
end_verts=[]
valid=true
num_verts.each_pair {|v,num|
	if num==1   #a start or end point of the path
		end_verts.push(v)
		valid=false if end_verts.length>2   #the path is not valid if there are more than two end points
	end
	if num>2  #the path is not valid
		valid=false
	end
}
return false if not valid
@path=[]   #the ordered points that will make up the path
if end_verts.length==0  #no end vertex found, so we must have a closed loop
	first_vertex=edges[0].start   #it shouldn't matter what vertex we start at so pick the start vertex of the first edge
else
	first_vertex=first_vertex||end_verts[0]     #pick the first end vertex found and give the user the option of reversing the path later
end
@path.push(first_vertex.position)
current_edge=edges.find {|edge| edge.vertices.index(first_vertex)}
num_edges=edges.length
current_vertex=first_vertex
num_edges.times {|i|
	verts=current_edge.vertices
	next_vert=current_edge.other_vertex(current_vertex)
	@path.push(next_vert.position)
	current_vertex=next_vert
	vert_edges=current_vertex.edges
	vert_edges.delete_if {|e| !edges.include?(e)}  #remove any edge found that is not in the selected path of edges
	vert_edges.delete_if {|e| e==current_edge}	#delete the current edge from the set of edges - there should be only one edge left
	if vert_edges.length>1
		p "Error computing path"
		@path=[]
		return false
	elsif (vert_edges.empty?) and (i<(num_edges-1))#this is possible if there are independent edges in the selection
		return false
	end
	current_edge=vert_edges[0]
}
return true
end
#
def add(point)
@path.push(point)
return self
end
#
def pop()
return @path.pop()
end
#
def first
return @path.first
end
#
def last
return @path.last
end
#
def reverse!
@path.reverse!
end
#
def transform!(trans)
@path=@path.collect {|p| p.transform(trans)}
self
end
#
def [](index)
return @path[index]
end
##
def []=(index,value)
@path[index]=value

end
#
def convert_pts_to_arrays
return @path.collect {|p| p.to_a}
end

def offset!(x_distance,y_distance)
offset_path=[]
num_edges=@path.length-1
#set the first offset point
p1=@path[0]
p2=@path[1]
local_trans=self.transformation_at(0)
local_x=local_trans.xaxis
local_x.length=x_distance 
local_y=local_trans.yaxis
local_y.length=y_distance
offset_vec=local_x+local_y
offset_pt=p1.offset(offset_vec) 
offset_path[0]=offset_pt
start_offset_pt=offset_pt
#the other offset points will depend also on the orientation of the next edge
num_edges.times {|i|
	
	p1=@path[i]
	p2=@path[i+1]
	this_edge_vec=p1.vector_to(p2)
	
	extruded_offset_pt=start_offset_pt.offset(this_edge_vec)
	offset_path[i+1]=extruded_offset_pt
	
	if @path[i+2]!=nil  #make sure there is another edge after this one
		p1=@path[i+1]
		p2=@path[i+2]
		next_edge_vec=p1.vector_to(p2)
		
		local_trans=self.transformation_at(i+1)
		local_x=local_trans.xaxis
		local_x.length=x_distance
		local_y=local_trans.yaxis
		local_y.length=y_distance	
		
		offset_vec=local_x+local_y
		next_offset_pt=p1.offset(offset_vec) #offset the point
		next_extruded_offset_pt=next_offset_pt.offset(next_edge_vec)
		
		#now calculate the corrected initially extruded point
		this_edge=[start_offset_pt,extruded_offset_pt]
		next_edge=[next_offset_pt,next_extruded_offset_pt]
		closest_pts=Geom.closest_points(this_edge,next_edge)
		if this_edge_vec.samedirection?(next_edge_vec)
			corrected_extruded_offset_pt=extruded_offset_pt
		else
			mid_point=Geom.linear_combination(0.5,closest_pts[0],0.5,closest_pts[1])
			corrected_extruded_offset_pt=mid_point
		end
		
		offset_path[i+1]=corrected_extruded_offset_pt  #replace the point with the corrected one
	else
		local_trans=self.transformation_at(i)
		local_x=local_trans.xaxis
		local_x.length=x_distance
		local_y=local_trans.yaxis
		local_y.length=y_distance	
		
		offset_vec=local_x+local_y
		offset_pt=p2.offset(offset_vec)  #offset the point
		offset_path[i+1]=offset_pt
	end
	start_offset_pt=next_offset_pt
}
if self.closed_path?
	@path=offset_path
	equalize_first_and_last_point()
else
	@path=offset_path
end
end
#
def equalize_first_and_last_point()
p0=path[0]
p1=path[1]
first_edge_vector=p1.vector_to(p0)
first_edge_line=[p1,first_edge_vector]
p2=@path[-1]
p3=@path[-2]
last_edge_vector=p3.vector_to(p2)
last_edge_line=[p3,last_edge_vector]
closest_pts=Geom.closest_points(first_edge_line,last_edge_line)
mid_point=Geom.linear_combination(0.5,closest_pts[0],0.5,closest_pts[1])
@path[0]=mid_point
@path[-1]=mid_point.clone
end
#
def offset_global_z!(distance)
y_offset_vec=Geom::Vector3d.new(0,0,1)
y_offset_vec.length=distance
y_trans=Geom::Transformation.new(y_offset_vec)
@path=@path.collect {|p| p.transform(y_trans)}
end #y_offset
###
def draw(view)
marker_size=40
view.line_width=6
if self.num_points>1
	lines=self.edges()
	first_line_vec=lines[0][0].vector_to(lines[0][1])
	last_line_vec=lines[-1][1].vector_to(lines[-1][0])
	start_marker_length=[view.pixels_to_model(marker_size,lines[0][0]),lines[0][0].distance(lines[0][1])].min
	end_marker_length=[view.pixels_to_model(marker_size,lines[-1][1]),lines[-1][0].distance(lines[-1][1])].min
	chain_start=lines[0][0].clone
	chain_end=lines[-1][1].clone
	first_line_vec.length=start_marker_length
	last_line_vec.length=end_marker_length
	offset_chain_start=chain_start.offset(first_line_vec)
	offset_chain_end=chain_end.offset(last_line_vec)
	view.drawing_color=START_EDGE_COLOR
	view.draw_line(chain_start,offset_chain_start)
	view.drawing_color=END_EDGE_COLOR
	view.draw_line(offset_chain_end,chain_end)
	lines[0][0]=offset_chain_start
	lines[-1][1]=offset_chain_end
	view.drawing_color=SELECTED_EDGE_COLOR
	lines.each {|line| view.draw_line(line[0],line[1])}
end
#draw_all_axis(view)
end
##
def draw_all_axis(view)
edges=self.edges()
edges.each_index {|i|
	trans=self.transformation_at(i)
	draw_axis(view,trans)
}
end
##
def draw_axis(view,trans)
view.line_width=3
origin=trans.origin
dist=view.pixels_to_model(32,origin)
x_axis=trans.xaxis
y_axis=trans.yaxis
z_axis=trans.zaxis
x_axis.length=dist
y_axis.length=dist
z_axis.length=dist
px=origin.offset(x_axis)
py=origin.offset(y_axis)
pz=origin.offset(z_axis)
view.drawing_color="red"
view.draw_line(origin,px)
view.drawing_color="green"
view.draw_line(origin,py)
view.drawing_color="blue"
view.draw_line(origin,pz)
end
private

	###
	def calc_trans_array()
	previous_x_axis=nil
	previous_y_axis=nil
	previous_z_axis=nil
	@edge_trans_array=[]
	@point_trans_array=[]
	edges=get_edges()
	edges.each_index {|i|
		edge=edges[i]
		origin=Geom::Point3d.new(edge[0])
		end_pos=Geom::Point3d.new(edge[1])
		
		zaxis=origin-end_pos
		if zaxis.length==0.0
			zaxis=Geom::Vector3d.new(0,0,1)
		end
		
		if previous_x_axis!=nil
			
			y_axis=zaxis.cross(previous_x_axis)
			fix_vector!(y_axis)
			
			if !y_axis.valid?
				y_axis=previous_y_axis
			end
			
			if y_axis.samedirection?(previous_y_axis.reverse)
				y_axis=previous_y_axis.clone
			end
			
			x_axis=y_axis.cross(zaxis)
			fix_vector!(x_axis)
			if x_axis.samedirection?(previous_x_axis.reverse)
				x_axis=previous_x_axis.clone
				y_axis=zaxis.cross(x_axis)
				fix_vector!(y_axis)
			end
		
			if !zaxis.samedirection?(previous_z_axis) and !x_axis.samedirection?(previous_x_axis) and !y_axis.samedirection?(previous_y_axis)
				trans=Geom::Transformation.new(origin,zaxis) #this will keep the y axis upright for helical paths
				#previous_edge_trans=@edge_trans_array[i-1]
				#t=Geom::Transformation.interpolate(previous_edge_trans, trans, 0.5)
				#@point_trans_array[i]=Geom::Transformation.new(t.xaxis,t.yaxis,t.zaxis,origin)
				#@point_trans_array[i]=trans
			else
				trans=Geom::Transformation.new(x_axis,y_axis,zaxis,origin)
			end
		else
			trans=Geom::Transformation.new(origin,zaxis)
		end
		previous_x_axis=trans.xaxis
		previous_y_axis=trans.yaxis
		previous_z_axis=trans.zaxis
		
		@edge_trans_array.push(trans)
	}
	end
	##
	def fix_vector!(vec)
	x=vec.x
	y=vec.y
	z=vec.z
	x=x.abs if x==0.0
	y=y.abs if y==0.0
	z=z.abs if z==0.0
	vec.set!(x,y,z)
	end
end #class
end #module ProfileBuilder2
end #module DM
