module DM
module ProfileBuilder2
DEFAULT_MAT_NAME="pb_default_mat"
class PBMaterial
def initialize(su_mat)
if su_mat.kind_of?(String)
	mats=Sketchup.active_model.materials
	if su_mat!=DEFAULT_MAT_NAME
		su_mat=mats[su_mat]
	else
		su_mat=nil
	end
end
if su_mat
	@su_material=su_mat
	@su_color=su_mat.color
	@su_alpha=su_mat.alpha
	@su_name=su_mat.name
	@su_texture=su_mat.texture
	if @su_texture
		@has_texture=true
		@su_texture_filename=@su_texture.filename
		@su_texture_width=@su_texture.width
		@su_texture_height=@su_texture.height
		save_texture_to_temp()
	end
	@su_dicts=su_mat.attribute_dictionaries
	if @su_dicts
		@dicts={}
		@su_dicts.each {|su_dict|
			dict={}
			su_dict.each {|key,val| dict[key]=val}
			@dicts[su_dict.name]=dict
		}
	end
end
end
##
def save_texture_to_temp()
if @has_texture
	tw=Sketchup.create_texture_writer
	group=Sketchup.active_model.entities.add_group
	group.material=@su_material
	tw.load(group)
	f_name=File.join(Sketchup.temp_dir,File.basename(@su_texture_filename))
	status=tw.write(group,f_name)
	@su_texture_filename=f_name
end
end
##
def to_su_material()
if @su_material
	mats=Sketchup.active_model.materials
	mat=mats[@su_name]
	if mat==nil 
		mat=mats.add(@su_name)
		mat.color=@su_color
		mat.alpha=@su_alpha
		if @has_texture
			mat.texture=@su_texture_filename
			mat.texture.size=[@su_texture_width,@su_texture_height]
		end
		if @dicts
			@dicts.each {|name,dict|
				dict.each {|key,val| mat.set_attribute(name,key,val)}
			}
		end
	end
	return mat
else
	return nil
end
end

end #PBmaterial
end #module profile builder
end #module DM
