require 'sketchup.rb'
module DM
module ProfileBuilder2
##
class PickerTool
include Geometry
def initialize(&block)
@sel=Sketchup.active_model.selection
@picked_group=nil
@callback=block
@tooltip=""
plugins=PATH
valid_cursor=File.join(plugins,"dropper_valid.png")
@valid_cursor=UI.create_cursor(valid_cursor,5,25)
invalid_cursor=File.join(plugins,"dropper_invalid.png")
@invalid_cursor=UI.create_cursor(invalid_cursor,5,25)
@cursor=@valid_cursor
@previewer=ComponentPreviewer.new
ro=Sketchup.active_model.rendering_options
@highlight_color=ro["HighlightColor"]
@sel.clear

end
##
def activate
Sketchup.set_status_text(self.get_status_text())
end
##
def get_status_text()
return ""
end
##
def onSetCursor
UI.set_cursor(@cursor) if @cursor
end
def onMouseMove(flags,x,y,view)
@trans=Geom::Transformation.new
ph=view.pick_helper
ph.do_pick(x,y)
best=ph.best_picked
validate_and_select_picked(best)
@trans=@picked_group.transformation if @picked_group
view.invalidate
end

###
def draw(view)
view.tooltip=@tooltip
view.drawing_color=@highlight_color
view.line_width=2
if @picked_group
	@previewer.definition=@picked_group.definition
	@previewer.transformation=@trans
	@previewer.draw_bounds()
end
end
end #picker tool
##
class ProfileMemberPickerTool < PickerTool
##
def onMouseMove(flags,x,y,view)
@trans=Geom::Transformation.new
best=get_inst_below_cursor(view,x,y,false)
validate_and_select_picked(best)
@trans=get_trans_below_cursor(view,x,y) if @picked_group
view.invalidate
end
##
def validate_and_select_picked(best)
@picked_group=nil
@tooltip="不是轮廓放样模型"
@cursor=@invalid_cursor
	
if best.class==Sketchup::Group or best.class==Sketchup::ComponentInstance
	if Classify.profile_member?(best)
		@picked_group=best
		pm=ProfileMember.new(best)
		@tooltip=pm.profile.name
		@cursor=@valid_cursor
		#@sel.add(best)
	else
		@picked_group=nil
		@tooltip="不是轮廓放样模型"
		@cursor=@invalid_cursor
		#@sel.clear
	end
end

end
##
def onLButtonDown(flags, x, y, view)
ent=@picked_group
if Classify.profile_member?(ent)
	pm=ProfileMember.new(ent)
	@callback.call(pm)
	Sketchup.active_model.select_tool(nil)
end
end
##
def get_status_text()
text="请从模型中选择一个由轮廓组件放样生成的轮廓放样模型"
return text
end
end  #class
###
class ComponentPickerTool < PickerTool
def validate_and_select_picked(best)
if best.class==Sketchup::ComponentInstance
	@picked_group=best
	@tooltip=best.definition.name
	@cursor=@valid_cursor
	#@sel.add(best)
else
	@picked_group=nil
	@tooltip="不是组件"
	@cursor=@invalid_cursor
	#@sel.clear
end
end
##
def onLButtonDown(flags, x, y, view)
ent=@picked_group
if ent
	@callback.call(ent)
	Sketchup.active_model.select_tool(nil)
end
end
##
def get_status_text()
text="请从模型中选择一个组件"
return text
end
end #class component picker
###
class AssemblyPickerTool < ComponentPickerTool

def validate_and_select_picked(best)
@picked_group=nil
@tooltip="不是组件"
@cursor=@invalid_cursor
	
if best.class==Sketchup::Group or best.class==Sketchup::ComponentInstance	
	if Classify.assembly?(best)
		a=Assembly.get(best)
		@picked_group=best
		@tooltip=a.fence.name
		@cursor=@valid_cursor
	end
end
end
##
def get_status_text()
text="请从模型中选择一个组件"
return text
end
end #class picker
 
end #module ProfileBuilder2

end #module DM
