require 'sketchup.rb'
#Changelog
#Version 2.0.3
#renamed internal modules and files so that PB2 can be installed alongside PB1
#added release notes to manual
#Version 2.0.2
#fixed occasional bug with polyline profile normals - now all polyline profiles must now be drawn on the XY plane
#fixed a bug with assembly dynamic preview of profile members with holes and setbacks
#packed in profile libraries with plugin
#fixed bug with creating a new profile by copy
#fixed a bug with editing the height and width of a profile inside of an assembly
#profiles with textured materials will now have back faces painted as well
#Version 2.0.1 (RC1)
#fixed sorting of material list
#changed how undoing works when building - it will now undo the entire member or assembly
#filtering search results is now case insensitive
#fixed text overflow with component and profile picker buttons
#fixed incorrect end component placing for vertical assemblies
#fixed funky characters in HTML reports
#made profile attributes picker work through groups and components outside active context
#fixed profilemember preview in assembly tool showing setbacks
#fixed saving and loading of assembly infill components with horizontal spacing turned off
#fixed a bug with placement of non-infill assembly components
#fixed mirror setting of assembly components
#finalized manual
#added tooltips
#fixed saving of dialog size and location preferences (Windows)
#fixed creation of single edge 1D profiles
#Version 2.0 beta 3
#added tool cursors (first draft)
#revised some icons
#increased text size for dialogs
#fixed default units for Layer$ and Material$ to match model settings
#fixed a bug with the path extruder algorithm
#adjusted some default dialog sizes
#improved status text for build tool and assembly build tool
#fixed bug with properties selection dialog box
#fixed bug with profiles being saved up-side down
#made it so the backspace key doesn't undo beyond the initial path point
#fixed bug where Layer$ and Material$ dialogs could refer to invalid layers or materials
#fixed some bugs with the surface area calculation within the Quantifier
#made setting for number of sides persist for the Revolve tool
#changed operation of trim tools - now, first choose trimmer entity, then choose profile member(s)
#you can now select objects when using the Show Missing Cost Data tool
#fixed several bugs with the Quantifier cost and quantity calculations
#put all context menu items inside a submenu
#fixed bug with importing a profile with material and duplicate materials being created
#fixed a bug with saving and loading of assembly names
#Version 2.0 beta 2
#added better validation checks for Profile Loading
#fixed some issues with the Trim to solid tool
#fixed broken features on OSX
#adjusted size of Properties Selector dialog (used for select-by attributes)
#made Properties selector dialog non-modal on Windows

#Version 2.0 beta 1
#initial release

#Version 1.1
#updates for compliance with SketchUp 2013
#made smoothing edges faster on Mac
#Version 1.0
#added BoolTools in links submenu
#added option for CSV or Plain Text Quantity Reports
#Version RC6
#fixed mac webdialog in background issue (hopefully)
#Version RC5
#added 'Links' submenu
#attempting to fix mac webdialog in background issue
#path group no longer auto-selected when clicking 'edit path'
#Version RC4
#Fixed path defined by lengths input into the VCB
#fixed some Mac issues on SU7 
#Version RC3
#Rotation and placement point displayed in profile preview 
#Mirror transformation now applied after offset transformation
#% complete status text for softening edges
#Added icon to build tool
#Added text prompt to assist in path editing
#if the file 'library_path.txt' exists in the ProfileBuilder directory, it will be used to determine the library path (eg. useful for network shared libraries)
#Version RC2
#You can now create a member by selecting a single face and clicking the 'Build Along Path' button
#Changed icon sizes to make dialog smaller on Mac systems
#Added Profile Builder Toolbar Button
#Made preview window load first profile in library when dialog is first opened
#All Profile Libraries must now be located in the ProfileBuilder/Libraries Folder 
#Fixed default size of dialog and disabled scrollbars - must test with SU7 - and change registry value for final release
#Removed redundant "Please select valid path" messagebox when user chooses to not to create unique members along discontinous edges
#When placing unique members on a group of pre-selected edges, the entire operation is now undoable in one step
#issues
#todo
#create promotional video
#create house tutorial
#bugs/issues
#make unique warning message
#if you have no libraries and you try to create a new library but then cancel, you will be unable to create a new library unless you first close the dialog and reopen
#dynamic drawing of geometry
#Profile Members sometimes disappear in SU6 for some users
######Future features##########
#material densities assigned to material attributes
#planar cutbacks
#SDNF import/export
#quasi drawing extraction
#direct excel exporting
#split member
#extend member to intersection
#######Extensions
#stud wall builder
#fence builder
#deck builder
#handrail builder
#truss builder

module DM
module ProfileBuilder2

ON_MAC=((Object::RUBY_PLATFORM =~ /mswin/i)||(Object::RUBY_PLATFORM =~ /mingw/i)) ? false : ((Object::RUBY_PLATFORM =~ /darwin/i) ? true : :other)
USER_DATA=ON_MAC ? (File.join(ENV['HOME'],"Library","Application Support","ProfileBuilder")) : (File.join(ENV['APPDATA'],"ProfileBuilder"))
Dir.mkdir(USER_DATA) unless FileTest.exist?(USER_DATA)
DEFAULT_PROFILE="请载入截面... 3.929203823352367 4.0 2.7964601911676112 4.0 0.0 1.2035398088323817 0.0 0.0 0.3003639209265927 0.0 0.3130053980477854 0.06209879089682957 0.3393234228461921 0.11974797428535666 0.37796248909738495 0.16997833695464948 0.42693249704232983 0.21020277102806517 0.4837112531999921 0.2383495225962946 0.6222082675369407 0.2710307808941259 0.6832675004887889 0.29659079409831435 0.7377579110604131 0.33417189785273393 0.7833457432769606 0.382164540595781 0.8180785274340963 0.43851325760299886 0.8404687019278683 0.5008047039644659 0.849557323653336 0.5663710151219199 1.0619474555371369 0.5663710151219199 1.0619474555371369 1.1170382034873434 1.456394752838186 1.2333535534081257 1.8048155173207903 1.451804696350095 2.0813536082902715 1.7561804759684136 2.2654872643695114 2.1238933091333436 2.537491855143415 2.588422103624559 2.9164607768147945 2.9707257195121635 3.3785888012859004 3.246789457282894 3.894846996621112 3.399272158146811|extended|1|false|0.0|0.0|0.0|30.0|1.0|1.0|2|Default|Layer0\n"

def ProfileBuilder2::build_ui()
if Sketchup.version_number>15000000
	#good to go
else
	UI.messagebox("截面组件放样2需要sketchup2015或更高版本.")
	p "SketchUp 2015 required"
	return
end
ext_id="98f4ede5-0b94-466a-adb7-ff2fc94065cb"
ext_lic = Sketchup::Licensing.get_extension_license(ext_id)
if ext_lic.licensed?
	#good to go
else
	#UI.messagebox(ext_lic.state)
	if ext_lic.state == Sketchup::Licensing::TRIAL_EXPIRED
		UI.messagebox("The trial period for Profile Builder 2 has expired.")
	else
		UI.messagebox("License not found for Profile Builder 2")
	end
	return
end
##################################
case state
when 1,-1
	#tb.show
when 0
	#tb.hide
end

end #build_ui
#ProfileBuilder2::build_ui()
module Classify
###
def self.profile_member?(ent)
dicts=nil
defn_dicts=nil
has_profile=false
if ent.kind_of?(Sketchup::Group)
	dicts=ent.attribute_dictionaries #version 1.0 backward compatible
	defn_dicts=ent.entities.parent.attribute_dictionaries  #version 2.0
elsif ent.kind_of?(Sketchup::ComponentInstance)
	defn_dicts=ent.definition.attribute_dictionaries #version 2.0
end
if dicts
	if dicts["ProfileBuilder"] and dicts["ProfileBuilder"]["profile"]
		has_profile=true
	end
end
if defn_dicts
	if defn_dicts["ProfileBuilder"] and defn_dicts["ProfileBuilder"]["profile"]
		has_profile=true
	end
end
return has_profile
end
##
def self.assembly?(ent)
if ent.kind_of?(Sketchup::Group)
	defn=ent.definition
elsif ent.kind_of?(Sketchup::ComponentInstance)
	defn=ent.definition
else
	defn=ent
end
return defn.get_attribute("PBFence","is_fence",false)
end
end #end module classify
##
def ProfileBuilder2.edit_path()
model=Sketchup.active_model
e=model.active_path.last
if Classify.profile_member?(e)
	pm=ProfileMember.new(e)
	if !pm.revolved?
		model.start_operation("Start Path Edit",true)
		edges=pm.draw_path()
		epmo=EditingProfileMemberObserver.new(pm)
		pm.instance.add_observer(epmo)
		item="Profile Member"
		model.commit_operation
	end
elsif Classify.assembly?(e)
	model.start_operation("Start Path Edit",true)
	defn=e.definition
	a=Assembly.get(defn)
	edges=a.draw_path()
	efo=EditingFenceObserver.new
	e.add_observer(efo)
	item="请加载构件..."
	model.commit_operation
end
#Sketchup.active_model.select_tool(pet) if pet
text="利用sketchup自带的工具编辑
#{item}的路径. 当你关闭这个组的时候, #{item} 将会按照新的路径更新.
 如果路径不可见，请使用 视图 / 组件编辑 / 隐藏剩余模型 
 ."
 
model=Sketchup.active_model
view=model.active_view
target=view.guess_target
eye=view.camera.eye
pt=edges[0].start.position
vec=eye.vector_to(target).reverse
vec.length=0.1*vec.length
vec.reverse!
target=target.offset(vec)
#Sketchup.active_model.active_entities.add_text(text,target)
end
def ProfileBuilder2.get_valid_filename(f_name)
illegal="\\\/:*?\"<>|" 
return f_name.delete(illegal)
end

def ProfileBuilder2.pmpi_at_cursor(view,x,y)
ray=view.pickray(x,y)
rt=Sketchup.active_model.raytest(ray)
e=rt[1][-2]
if e and Classify.profile_member?(e)	
	if !e.valid?
		UI.messagebox("Entity not valid")
	else
		Sketchup.active_model.start_operation("PMPI")
		pm=ProfileMember.new(e)
		pm.pmpi()
		Sketchup.active_model.commit_operation
	end			
end
end
##
def ProfileBuilder2.import_plb
default_path=File.dirname(get_last_profile_path)
plb=UI.openpanel("Import PLB", default_path,"PLB|*.plb||")
return if not plb
new_library=ProfileLibrary.new(plb)
library_name=File.basename(plb,".plb")
lib_dir=File.dirname(plb)
new_lib_dir=UI.select_directory(
   title: "Select Output Folder",
   directory: lib_dir
 )
 return if new_lib_dir==nil
profiles=new_library.profiles
num_profiles=profiles.length
count=0
pbar=ProgressBar.new("Import PLB",profiles) {|profile|
	profile.name=ProfileBuilder2.get_valid_filename(profile.name)
	profile.save_skp(new_lib_dir)
}
Sketchup.active_model.active_view.animation=pbar
end

def ProfileBuilder2.get_last_profile_path()
default_path=""
last_path=Sketchup.read_default("ProfileBuilder","LastProfilePath",default_path)
return last_path
end
def ProfileBuilder2.get_last_assembly_path()
default_path=""
last_path=Sketchup.read_default("ProfileBuilder","LastAssemblyPath",default_path)
return last_path
end
#
def ProfileBuilder2.save_last_profile_path(path)
path.gsub!(/\\/,"\/")
last_path=Sketchup.write_default("ProfileBuilder","LastProfilePath",path)
return last_path
end
def ProfileBuilder2.save_last_assembly_path(path)
path.gsub!(/\\/,"\/")
last_path=Sketchup.write_default("ProfileBuilder","LastAssemblyPath",path)
return last_path
end
##############
def ProfileBuilder2.pmpi()
sel=Sketchup.active_model.selection
if sel.empty?
	UI.messagebox("请选择至少一个轮廓放样模型.")
end
Sketchup.active_model.start_operation("PMPI")
sel.each {|e|
	if Classify.profile_member?(e)
		pm=ProfileMember.new(e)
		pm.pmpi(pm.transformation)
	end
}
sel.clear
Sketchup.active_model.commit_operation
end
##############
def ProfileBuilder2.clear_pmpi()
#Sketchup.active_model.start_operation("Clear PMPI")
paths=[]
instances=[]
defns=Sketchup.active_model.definitions
defns.each {|defn| instances.concat(defn.instances)}
instances.each {|e|
	if e.get_attribute('PMPI','pmpi_path')==true
		paths.push(e)
	elsif Classify.profile_member?(e)
		if e.get_attribute('PMPI','pmpi_hidden')==true
			e.hidden=false
			e.set_attribute('PMPI','pmpi_hidden',false)
		end
	elsif Classify.assembly?(e)
		if e.get_attribute('PMPI','pmpi_hidden')==true
			e.hidden=false
			e.set_attribute('PMPI','pmpi_hidden',false)
		end
	end
}
Sketchup.active_model.active_entities.erase_entities(paths)
#Sketchup.active_model.commit_operation
end
###################################
def ProfileBuilder2.assign_mark_numbers()
sel=Sketchup.active_model.selection
if sel.empty?
	UI.messagebox("请选择至少一个轮廓放样模型.")
	return
end
prompts=["前缀","后缀","开始数字"]
values=["","","0"]
results=UI.inputbox(prompts,values,"分配标记号")
return if not results
prefix=results[0]
suffix=results[1]
first=results[2]
first=first.to_i unless first==""
Sketchup.active_model.start_operation("分配标记号")
ents=Sketchup.active_model.selection
if ents.empty?
	ents=Sketchup.active_model.entities
end
qmember_list=QMemberList.new
qmember_list.get_qmembers(ents)
renamed=0
qmember_list.each {|m|
	if m.profile_member?
		p_name=m.profile_member.profile.name
		defn=m.definition
		inst=m.instance
		new_name=prefix+first.to_s+suffix
		if new_name.include?("$P")
			new_name=new_name.gsub(/\$P/,p_name)
		end
		defn.name=new_name
		inst.name=p_name if inst.name==""
		first+=1 unless first==""
		renamed+=1	
	end
}
Sketchup.active_model.commit_operation
UI.messagebox("成功给 #{renamed}个轮廓放样模型分配标记号.")
end
class ProfileBuilderTool
include Geometry
include WebDialogHelper
private_class_method :new  #used to make singleton
@@profile_library=nil
@@profile_builder_tool=nil  #will store the one and only instance of this class
@@editing_profile_member=nil  #will store the profile member whose path is currently being edited
@@editing_path_group=nil  #will store the path group that is currently being used for editing
@@modal_dialog=nil
attr_reader :profile, :rotation, :mirror, :placement_point, :x_offset, :y_offset, :smooth_angle, :size_x, :size_y
####create a new instance of the tool or return the already created instance
def ProfileBuilderTool.create
	@@profile_builder_tool=new unless @@profile_builder_tool
	return @@profile_builder_tool
end
def ProfileBuilderTool.create_modal
	@@modal_dialog=new unless @@modal_dialog
	return @@modal_dialog
end
def initialize
	@ip1 = nil
    @ip2 = nil
    @xdown = 0
    @ydown = 0
	@chain=Chain.new
	@member=nil	#will store the profile member object created by the tool
	@profile=Profile.new(DEFAULT_PROFILE)
	@lock_aspect=true
	@library=Sketchup.active_model.get_attribute('ProfileBuilder','library',nil)
	plugins=PATH
	build_icon=File.join(plugins,"cursors/build_cursor.png")
	@cursor=UI.create_cursor(build_icon,1,1)
	
	last_profile=ProfileBuilder2.get_last_profile_path()
	@profile.load_from_skp(last_profile) if FileTest.exist?(last_profile)
	
	@selection_observer=SelectionObserver.new {set_selection_status()}
	Sketchup.active_model.selection.add_observer(@selection_observer)
	@model_observer=ModelObserver.new {validate_edit_path()}
	Sketchup.active_model.add_observer(@model_observer)
	
	if ON_MAC
		@dlg=UI::WebDialog.new("家居定制版-截面放样", false,"PB2Dialog",270,460,150,150,true)
	else
		@dlg=UI::WebDialog.new("家居定制版-截面放样", false,"PB2Dialog",300,540,150,150,true)
	end
	@dlg.set_file(File.join(PATH,"dialog.html"))
	color = @dlg.get_default_dialog_color 
	@dlg.set_background_color(color)
	@dlg.set_on_close {clean_up()}
	@dlg.add_action_callback("port_key") { |_, keycode|
		keycode=keycode.to_i
		case keycode
		when VK_DELETE,VK_HOME,VK_END,COPY_MODIFIER_KEY
			#if keycode==COPY_MODIFIER_KEY
				self.onKeyDown keycode, false, 0, Sketchup.active_model.active_view#This tool doesn't use flags so it can just be set to 0
			#end
		end
	}
	@dlg.add_action_callback("ValueChanged") {|d,p|
		pair=p.split("|")
		id=pair[0]           
		value=pair[1]
		#the following code handles any events that occur in the webdialog
		case id
			when "lockAspect"
				if @lock_aspect
					@lock_aspect=false
					@dlg.execute_script("unlocklockAspect();")
				else
					@lock_aspect=true
					@dlg.execute_script("lockAspect();")
				end
			when "drawProfileButton"
				drawProfile()
			when "saveButton"
				save_profile(@profile)
			when "profileBrowseButton"
				browseProfile()
			when "profileName"
				if value!=ProfileBuilder2.get_valid_filename(value)
					UI.messagebox("Profile names cannot contain any of the following characters: \\\/:*?\"<>|") 
					value=ProfileBuilder2.get_valid_filename(value)
					@profile.name=value
					refresh_dialog()
				else
					@profile.name=value
				end
			when "placementPoint"
				@profile.placement_point=value.to_i
				self.refresh_preview()
			when "rotation"
				if value
					v_h=value.split(":")
					if v_h.length==2
						value=(v_h[0].to_f)/(v_h[1].to_f)
						value=Math::atan(value).radians
					end
					@profile.rotation=value.to_f
					self.refresh_preview()
				end
			when "xOffset"
				@profile.x_offset=Sketchup.parse_length(value).to_f
				self.refresh_preview()
			when "yOffset"
				@profile.y_offset=Sketchup.parse_length(value).to_f
				self.refresh_preview()
			when "width"
				new_width=Sketchup.parse_length(value).to_f
				if @lock_aspect					
					current_aspect=(@profile.width)/(@profile.height)
					new_height=new_width/current_aspect
					set_length("height",new_height)
					@profile.y_scale=new_height/@profile.default_height
					@profile.x_scale=new_width/@profile.default_width
				else
					@profile.x_scale=new_width/@profile.default_width
				end
				validateResetScale()
				self.refresh_preview()
			when "height"
				new_height=Sketchup.parse_length(value).to_f
				if @lock_aspect
					current_aspect=(@profile.width)/(@profile.height)
					new_width=current_aspect*new_height
					set_length("width",new_width)
					@profile.y_scale=new_height/@profile.default_height
					@profile.x_scale=new_width/@profile.default_width
				else
					@profile.y_scale=new_height/@profile.default_height
				end
				validateResetScale()
				self.refresh_preview()	
			when "resetScale"
				@profile.x_scale=1.0
				@profile.y_scale=1.0
				width=Sketchup.format_length(@profile.width).gsub(/"/,"\\\"")
				height=Sketchup.format_length(@profile.height).gsub(/"/,"\\\"")
				setValue("width",(width))
				setValue("height",(height))
				validateResetScale()
				self.refresh_preview()
			when "smoothAngle"
				@profile.smooth_angle=value.to_f
			when "mirror"
				@profile.mirror=true if value=="true"
				@profile.mirror=false if value=="false"
				self.refresh_preview()
			when "layerName"
				@profile.layer_name=value
			when "materialName"
				@profile.material_name=value
			when "drawMemberButton"
				Sketchup.active_model.select_tool(self)
			when "createProfileButton"
				create_profile()
			when "editMemberButton"
				sel=Sketchup.active_model.selection
				if sel.empty?
					UI.messagebox("请选择一个轮廓放样成员.")
				else
					props=PMPropertiesSelector.new(self,"edit")
					props.show
				end
				
			when "editPathButton"
				e=Sketchup.active_model.active_path.last
				if Classify.profile_member?(e)
					edit_path(ProfileMember.new(e))
				else
					UI.messagebox("请选择一个轮廓放样成员.")
				end
			
			when "createAlongPathButton"
				valid=validate_create_along_path()
				if valid
					path=PathSelectTool.get_selected_path()
				end
				if path
					@member=nil   
					@chain.set_path(path)
					Sketchup.active_model.start_operation("Build",true)
					place_member(Sketchup.active_model.active_view,true)
					Sketchup.active_model.commit_operation
				else
					edges=get_selected_edges()
					if edges.length>0		
						result=UI.messagebox("A valid path was not found.  Would you like to create a unique member along each edge?",MB_YESNO)
						if result==6  #yes
							Sketchup.active_model.start_operation("Build",true)
							edges.each{|edge|
								@member=nil
								@chain.set_path([edge.start.position,edge.end.position])
								place_member(Sketchup.active_model.active_view,false)
							}
							Sketchup.active_model.commit_operation
						end			
					end
					
				end
			when "addToFavouritesButton"
				if @profile
					self.add_to_favourites(@profile)
					refreshLibraryList()
					setValue("libraryName",@library)
				end
			when "acquireButton"
				Sketchup.active_model.select_tool(ProfileMemberPickerTool.new {|pm| self.set_values(pm)})
			when "selectByButton"
				props=PMPropertiesSelector.new(self,"select")
				props.show
			when "revolveButton"
				Sketchup.active_model.select_tool(LatheTool.new(@profile))
				
					
		end
	}
end
##
def validate_create_along_path()
sel=Sketchup.active_model.selection
if sel.empty?
	UI.messagebox("请至少选择一条线或者一个已经生成的轮廓放样模型.")
	return false
end
if @profile==nil
	UI.messagebox("文件未加载.")
	return false
end
return true
end
##
def get_selected_edges()
edges=Sketchup.active_model.selection.grep(Sketchup::Edge)
return edges
end
##
def clean_up()
remove_observers()
@browser.close if @browser
end
##
def browseProfile()
@browser.close if @browser
last_path=ProfileBuilder2.get_last_profile_path()
if FileTest.exist?(last_path)
	folder=File.dirname(last_path)
else
	folder=File.join(File.dirname(__FILE__),"Libraries","Profile Examples")
	if !FileTest.exist?(folder)
		folder=Dir.pwd
	end
end
@browser=SKPBrowser.new(folder,"Select Profile") {|skp|
	status=@profile.load_from_skp(skp)
	if status
		#setValue("profileName",@profile.name)
		@browser.close
		refresh_dialog()
		ProfileBuilder2.save_last_profile_path(skp)
		@dlg.bring_to_front
	end
}
@browser.show
end
##
def set_selection_status()
sel=Sketchup.active_model.selection
p_members=sel.find_all {|e| Classify.profile_member?(e)}
num_selected=p_members.length
case num_selected
	when 0
		cmd="$('#editMemberButton').button('disable');"
	when 1
		cmd="$('#editMemberButton').button('enable');"
	else
		cmd="$('#editMemberButton').button('enable');"
end
@dlg.execute_script(cmd)
end
##
def validate_edit_path()
a_path=Sketchup.active_model.active_path
if a_path
	e=Sketchup.active_model.active_path.last
	if Classify.profile_member?(e)
		cmd="$('#editPathButton').button('enable');"
	else
		cmd="$('#editPathButton').button('disable');"
	end
else
	cmd="$('#editPathButton').button('disable');"
end
@dlg.execute_script(cmd)
end
##
def create_profile()
sel=Sketchup.active_model.selection
added=0
new_profiles=[]
found_face=false
found_edge=false
copy_profile=false
default_name="Profile"
if @profile and sel.empty?
	default_name=@profile.name+"_copy"
	copy_profile=true
end
faces=sel.grep(Sketchup::Face)
edges=sel.grep(Sketchup::Edge)
found_face=true if faces.length>0
found_edge=true if edges.length>0
if found_face or found_edge or copy_profile
	skp=UI.inputbox(["Name"],[default_name],"Create New Profile")
	return if not skp
else
	UI.messagebox("请选择一个面或者折线.")
	return
end
p_name=skp[0]
if found_face and faces.length==1 
	p=Profile.new(faces.first)
	p.name=p_name
	@profile=p
	new_profiles.push(p)
elsif found_face and faces.length>1
	dir=UI.select_directory(title: "Choose Folder for Saving Multiple Profiles")
	return if dir==nil
	faces.each {|e|
		if added>=1
			name=p_name+"#{added}"
		else
			name=p_name
		end
		p=Profile.new(e)
		p.name=name
		new_profiles.push(p)
		p.save_skp(dir)
		added+=1
	}
	UI.messagebox("#{added} Profile(s) saved to folder #{dir}")
elsif found_edge 
	path=PathSelectTool.get_selected_path()
	unless path
		results=UI.messagebox("A valid path was not found.")
		return
	end
	plane=[Geom::Point3d.new(0,0,0),Geom::Vector3d.new(0,0,1)]
	off_plane=path.find {|p| !p.on_plane?(plane)}
	if off_plane
		UI.messagebox("All points on a polyline profile must be drawn on the XY plane.")
		return
	end
	chain=Chain.new(path)
	p=Profile.new(chain.path)
	p.name=p_name
	new_profiles.push(p)
	@profile=p
	added+=1				
elsif sel.empty?
	if @profile
		p=@profile.clone
		p.name=p_name
		new_profiles.push(p)
		added+=1
		@profile=p
	end
end
if new_profiles.first
	refresh_dialog()
else
	UI.messagebox("请至少选择一个面.")
end
end
##
def drawProfile()
Sketchup.active_model.start_operation("Stamp Profile",true,true)
model=Sketchup.active_model
defns=model.definitions
profile_defn=defns.add(@profile.name)
behavior=profile_defn.behavior
behavior.is2d=true
behavior.snapto=SnapTo_Arbitrary 
ents=profile_defn.entities
@profile.draw(ents)
model.place_component(profile_defn,false)
Sketchup.active_model.commit_operation
end
#################################
def show
	if ON_MAC == true
		@dlg.show_modal{refresh_dialog();validate_edit_path()} unless @dlg.visible?
	else
		@dlg.show{refresh_dialog();validate_edit_path()} unless @dlg.visible?
	end
	start_observers()
end
##
def show_modal(profile,&block)
@profile=profile.clone unless profile==nil
if @dlg.visible?
	@dlg.close()
end
@callback=block
@dlg.add_action_callback("apply") {|d,p|
	@callback.call(@profile)
	@dlg.close()
}
if ON_MAC == true
	@dlg.show_modal{refresh_dialog(true)}
else
	@dlg.show{refresh_dialog(true)}
end
end
##
def close
@dlg.close
end
def visible?
@dlg.visible?
end
##
def start_observers()
@materials_observer=MaterialsObserver.new
@materials_observer.caller=self
Sketchup.active_model.materials.add_observer(@materials_observer)
@layers_observer=LayersObserver.new
@layers_observer.caller=self
Sketchup.active_model.layers.add_observer(@layers_observer)
Sketchup.active_model.selection.add_observer(@selection_observer)
end
##
def remove_observers()
Sketchup.active_model.materials.remove_observer(@materials_observer) if @materials_observer
Sketchup.active_model.layers.remove_observer(@layers_observer) if @layers_observer
end
##
def refresh_dialog(modal=false)
set_selection_status()
refreshMaterialsList("materialName")
refreshLayersList("layerName")
getValuesFromSU()
set_modal_display() if modal
end
##
def set_modal_display()
cmd="showModalDisplay();"
@dlg.execute_script(cmd)
end
def set_length(id,val)
length=Sketchup.format_length(val).gsub(/"/,"\\\"")
setValue(id,length)
end
#################################
def getValuesFromSU()
if @profile
	setValue("profileName",@profile.name)
	set_length("width",@profile.width)
	set_length("height",@profile.height)
	
	set_length("xOffset",@profile.x_offset)
	set_length("yOffset",@profile.y_offset)
	setValue("placementPoint",(@profile.placement_point))  
	setValue("rotation",(@profile.rotation))
		
	setMaterialName()
	setLayerName()
	if @profile.mirror then setCheckbox("mirror","true")
		else setCheckbox("mirror","false")
	end
	
	validateResetScale()
	refresh_preview()
end
end
##
def validateResetScale()
if @profile.scaled?
	cmd="$('#resetScale').button( 'option', 'disabled', false );"
else
	cmd="$('#resetScale').button( 'option', 'disabled', true );"
end
@dlg.execute_script(cmd)
end
##
def setMaterialName()
id="materialName"
if @profile
	mat_names=Sketchup.active_model.materials.collect {|mat| mat.name}
	if mat_names.index(@profile.material_name)
		#setValue(id,(@profile.material_name))
		setSelectWidget(id,@profile.material_name)
	else
		@profile.material_name=@dlg.get_element_value(id)
		setValue(id,(@profile.material_name))
		#setSelectWidget(id,@profile.material_name)
	end
end
end
##
def setLayerName()
id="layerName"
if @profile
	layer_names=Sketchup.active_model.layers.collect {|layer| layer.name}
	if layer_names.index(@profile.layer_name)
		setValue(id,(@profile.layer_name))
		#setSelectWidget(id,@profile.layer_name)
	else
		@profile.layer_name=@dlg.get_element_value(id)
		setValue(id,(@profile.layer_name))
		#setSelectWidget(id,@profile.layer_name)
	end
end
end
###
def copy_to_profile()
profile=@profile.dup
return profile
end

###########################
def set_preview_title(profile)
width=Sketchup.format_length(profile.width).gsub(/"/,"\\\"")
height=Sketchup.format_length(profile.height).gsub(/"/,"\\\"")
title=[profile.name,"Width:"+width,"Height:"+height].join("|")
cmd="document.getElementById('Canvas').title=\"#{title}\""
@dlg.execute_script(cmd)
end
############################
def set_values(pm)
@profile.set_from_profile_member(pm)
self.refresh_dialog()
return
end
##
def save_profile(profile)
begin
	default_name=@profile.name
	default_name="Profile" if default_name==""
	last_path=ProfileBuilder2.get_last_profile_path()
	if FileTest.exist?(last_path)
		folder=File.dirname(last_path)
	else
		folder=Dir.pwd
	end
	skp=UI.savepanel("Save Profile",folder,default_name+".skp")
	return if not skp
	f_name=File.basename(skp,".*")
	@profile.save_skp(File.dirname(skp),f_name)
	ProfileBuilder2.save_last_profile_path(skp)
	UI.messagebox("Profile Saved.")
rescue
	UI.messagebox("Unable to save Profile.")
	raise
end
end

def refresh_preview()
	preview_profile(@dlg,@profile,@profile.placement_point,@profile.rotation,@profile.x_offset,@profile.y_offset,@profile.mirror,@profile.width,@profile.height,"Canvas")
end
################################
def preview_profile(dlg,profile,placement_point=5,rotation=0.0,x_offset=0.0,y_offset=0.0,mirror=false,x_size=nil,y_size=nil,canvis_id=nil)
	canvas=128 #the size of the web dialog canvas
	cent=(canvas.to_f/2.0).to_i
	origin=Geom::Point3d.new(0,0,0)
	center=Geom::Point3d.new(cent,cent,0)
	
	pts=profile.points
	pts=profile.get_transformed_loop(pts)
	preview_origin=Geom::Point3d.new(0,0,0)
	
	box=Geom::BoundingBox.new
	box.add(pts)
	box.add(preview_origin) 
	vec=center-box.center  
	trans1=Geom::Transformation.translation(vec)
			
	new_points=pts.collect {|p| p.transform(trans1)}
	preview_origin=preview_origin.transform(trans1)  #testing preview placement point
		
	box=Geom::BoundingBox.new
	box.add(new_points)
	box.add(preview_origin)  #new
	xmax=box.max.x-box.min.x
	ymax=box.max.y-box.min.y
	xymax=[xmax,ymax].max.to_f   
	scale=(canvas.to_f/xymax)
	trans2=Geom::Transformation.scaling(center,scale,-scale,scale)
	new_points=new_points.collect {|p| p.transform(trans2)}
	preview_origin=preview_origin.transform(trans2) 
	xpoints=new_points.collect {|p| p.x.to_i}
	ypoints=new_points.collect {|p| p.y.to_i}
	x_array="new Array("
	y_array="new Array("
	x_array+=xpoints.join(",")
	y_array+=ypoints.join(",")
	x_array+=")"
	y_array+=")"
	
	cmd="clearCanvas()"
	dlg.execute_script(cmd)
	cmd="drawProfile(#{x_array},#{y_array},\"#{canvis_id}\")" if profile.is_2d?
	cmd="drawPolyline(#{x_array},#{y_array},\"#{canvis_id}\")" if profile.is_1d?
	dlg.execute_script(cmd)
	
	#draw the holes in the profile
	profile.holes.each {|hole|
		#new code for rotation,mirror, and offset
		hole=profile.get_transformed_loop(hole)
			
		new_hole=hole.collect {|p| p.transform(trans1)}
		new_hole.push(hole[0].transform(trans1))  #add first point to close the loop
		new_hole=new_hole.collect {|p| p.transform(trans2)}
		
		
		xpoints=new_hole.collect {|p| p.x.to_i}
		ypoints=new_hole.collect {|p| p.y.to_i}
		x_array="new Array("
		y_array="new Array("
		x_array+=xpoints.join(",")
		y_array+=ypoints.join(",")
		x_array+=")"
		y_array+=")"
		cmd="drawHole(#{x_array},#{y_array},\"#{canvis_id}\")"
		dlg.execute_script(cmd)
	}
	
	origin_dot_size=6.0
	x=preview_origin.x.to_i-(origin_dot_size/2.0)
	y=preview_origin.y.to_i-(origin_dot_size/2.0)
	cmd="drawOrigin(#{x},#{y},\"#{canvis_id}\")"
	dlg.execute_script(cmd)
	
	#TODO - change this 
	#set_preview_title(profile)  #set the title of the profile preview
end
##################################################
def activate
@ip1 = Sketchup::InputPoint.new
@ip2 = Sketchup::InputPoint.new
@ip = Sketchup::InputPoint.new
@last_point=Geom::Point3d.new(0,0,0)
@drawn = false
@member=nil
@building=false
@operation_started=false
# This sets the label for the VCB
Sketchup::set_status_text("Length", SB_VCB_LABEL)
Sketchup::set_status_text(nil,SB_VCB_VALUE)
self.reset(nil)
end
###################################################
def deactivate(view)
ProfileBuilder2.clear_pmpi()
view.invalidate if @drawn
view.lock_inference
@member=nil
Sketchup.active_model.commit_operation if @operation_started
end
#######################
def onSetCursor
UI.set_cursor(@cursor) if @cursor
end
###################################################
#method to tell SU the extent of what to draw
def getExtents
box=Sketchup.active_model.bounds
box.add(@ip1.position) if @ip1.valid?
box.add(@ip.position) if @ip.valid?
box.add(@ip2.position) if @ip2.valid?
return box
end
##
def get_status_text()
case @state
when 0
	text="单击开始点. CTRL=PMPI(仅显示路径)"
else
	text="单击下一个点或者输入数据. CTRL=PMPI(仅显示路径). ESC、ENTER或鼠标右键完成."
end
return text
end
####################################################
def onMouseMove(flags, x, y, view)
	@x_current=x
	@y_current=y
	
    if( @state == 0 )
		Sketchup::set_status_text(get_status_text())
        @ip.pick view, x, y
        if( @ip != @ip1 )
            view.invalidate if( @ip.display? or @ip1.display? )
            @ip1.copy! @ip
            view.tooltip = @ip1.tooltip
        end
    else
      	Sketchup::set_status_text(get_status_text()) 
        @ip2.pick view, x, y, @ip1
        view.tooltip = @ip2.tooltip if( @ip2.valid? )
        view.invalidate
 		
		length = @ip1.position.distance(@ip2.position)
        Sketchup::set_status_text length.to_s, SB_VCB_VALUE
		
        # Check to see if the mouse was moved far enough to create a line.
        if( (x-@xdown).abs > 20 || (y-@ydown).abs > 20 )
            @dragging = true
        end
    end
end

def lock_axis(view,axis)
if view.inference_locked?
	view.lock_inference
end
if @state==1 and @ip2.valid?
	p2=@ip2.position
	p1=@ip1.position
	vec=p1.vector_to(p2)
	len=vec.dot(axis)
	len=1.0 if len==0.0
	offset_vector=Geom::Vector3d.new(axis)
	offset_vector.length=len
	@ip2=Sketchup::InputPoint.new(@ip1.position.offset(offset_vector))
	view.lock_inference(@ip1,@ip2)
end
end
###################################################
def onLButtonDown(flags, x, y, view)
   if( @state == 0 )
        @ip1.pick view, x, y
        if( @ip1.valid? )
            @state = 1
			@last_point=@ip1.position
			@chain.add(@last_point)
            Sketchup::set_status_text(get_status_text())
            @xdown = x
            @ydown = y
			Sketchup.active_model.start_operation("Build",true)
			@operation_started=true
        end
    else
        if( @ip2.valid? )				
				@last_point=@ip2.position
				@chain.add(@last_point)
				self.place_member(view,true)
				ProfileBuilder2.clear_pmpi()
				@ip1=Sketchup::InputPoint.new(@ip2.position)
				@drawn = false
				@dragging = false
				@left_down=@right_down=@up_down=@down_down=false
				path=@chain.path
				if @chain.num_points>2 and @chain.first==@chain.last
					self.reset(view)
				end
        end
    end
    
    # Clear any inference lock
    view.lock_inference
	view.invalidate
end
############################
def onLButtonUp(flags, x, y, view)
    # If we are doing a drag, then create the line on the mouse up event
   if(@dragging && @ip2.valid?)
		if @chain.num_points==1
			@last_point=@ip2.position
			@chain.add(@last_point)
			self.place_member(view,true)
			ProfileBuilder2.clear_pmpi()
			@ip1.copy! @ip2
			@drawn = false
			@dragging = false
		end
   end
end
##
def onReturn(view)
self.reset(view)
end
##
def getMenu(menu)
if @chain.num_points>1
	menu.add_item('完成') {self.reset(Sketchup.active_model.active_view)}
end
end
#########################
def onKeyDown(key, repeat, flags, view)
case key
when VK_DELETE, 8
	if @chain.num_points>1
		@chain.pop()
		@last_point=@chain.last
		@ip1=Sketchup::InputPoint.new(@last_point)
		if @chain.num_points>1
			self.place_member(view,true)
		else
			delete_member(view)
		end
	end
when VK_END
	@profile.rotation+=45.0
	if @profile.rotation>360.0
		@profile.rotation=@profile.rotation%360.0
	end
	getValuesFromSU()
when VK_HOME
	@profile.placement_point+=1
	if @profile.placement_point==10
		@profile.placement_point=1
	end
	getValuesFromSU()
when CONSTRAIN_MODIFIER_KEY
	@shift_down_time = Time.now
	# if we already have an inference lock, then unlock it
	if( view.inference_locked? )
		# calling lock_inference with no arguments actually unlocks
		view.lock_inference
	elsif( @state == 0 && @ip1.valid? )
		view.lock_inference @ip1
	elsif( @state == 1 && @ip2.valid? )
		view.lock_inference @ip2, @ip1
	end
when COPY_MODIFIER_KEY
	pmpi(view,@x_current,@y_current)
when VK_LEFT
	@left_down=!@left_down
	if @left_down
		lock_axis(view,Y_AXIS) 
	else
		view.lock_inference if view.inference_locked?
	end
	@right_down=@up_down=@down_down=false
when VK_RIGHT
	@right_down=!@right_down
	if @right_down
		lock_axis(view,X_AXIS) 
	else
		view.lock_inference if view.inference_locked?
	end
	@left_down=@down_down=@up_down=false
when VK_DOWN
	@down_down=!@down_down
	if @down_down
		lock_axis(view,Z_AXIS) 
	else
		view.lock_inference if view.inference_locked?
	end
	@up_down=@left_down=@right_down=false
when VK_UP
	@up_down=!@up_down
	if @up_down
		lock_axis(view,Z_AXIS) 
	else
		view.lock_inference if view.inference_locked?
	end
	@down_down=@left_down=@right_down=false
end
view.invalidate
end
##
def pmpi(view,x,y)
ray=view.pickray(x,y)
rt=Sketchup.active_model.raytest(ray)
if rt
	inst_path=rt[1]
	e=inst_path[-2]
end
if e and Classify.profile_member?(e)	
	if !e.valid?
		UI.messagebox("实体无效")
	else
		Sketchup.active_model.start_operation("PMPI") unless @operation_started
		pm=ProfileMember.new(e)
		trans=Geom::Transformation.new
		(inst_path.length-1).times {|i| trans=trans*inst_path[i].transformation}
		pm.pmpi(trans)
		#Sketchup.active_model.commit_operation
	end			
end
end
#################
def onKeyUp(key, repeat, flags, view)
	
    if( key == CONSTRAIN_MODIFIER_KEY &&
        view.inference_locked? &&
        (Time.now - @shift_down_time) > 0.5 )
        view.lock_inference
    end
	view.invalidate
end
##
def onUserText(text, view)
  
  
    # The user may type in something that we can't parse as a length
    # so we set up some exception handling to trap that
    begin
        value = text.to_l
    rescue
        # Error parsing the text
        UI.beep
        puts "Cannot convert #{text} to a Length"
        value = nil
        Sketchup::set_status_text "", SB_VCB_VALUE
    end
    return if !value
    # Compute the direction and the second point
    pt1 = @last_point
    vec = @ip2.position - pt1
    if( vec.length == 0.0 )
        #UI.beep
        return
    end
    vec.length = value
    pt2 = pt1 + vec
	@last_point=pt2
	@chain.add(@last_point)
    # Create a line
	self.place_member(view,true)
	ip_temp=Sketchup::InputPoint.new(pt2)   #Create a new inputpoint and set it to the point defined by the input length
	@ip1.copy! ip_temp
	 @drawn = false
  	 @dragging = false
    #self.reset(view)
end
##
def draw(view)
    if( @ip1.valid? )
        if( @ip1.display? )
            @ip1.draw(view)
            @drawn = true
        end
        
        if( @ip2.valid? )
            @ip2.draw(view) if( @ip2.display? )
            
           view.set_color_from_line(@last_point, @ip2)
			self.draw_geometry(@last_point, @ip2.position, view)
            @drawn = true
        end
    end
end
# onCancel is called when the user hits the escape key
def onCancel(flag, view)
    self.reset(view)
end

# The following methods are not directly called from SketchUp.  They are
# internal methods that are used to support the other methods in this class.
# Reset the tool back to its initial state
def reset(view)
    # This variable keeps track of which point we are currently getting
    @state = 0
    
    # Display a prompt on the status bar
    Sketchup::set_status_text(get_status_text())
    
    # clear the InputPoints
    @ip1.clear
    @ip2.clear
    
    if( view )
        view.tooltip = nil
        view.invalidate if @drawn
    end
    
	@member=nil
	@chain.clear
    @drawn = false
    @dragging = false
	@left_down=false
	@right_down=false
	@down_down=false
	@up_down=false
	view.lock_inference if view and view.inference_locked?
	if @operation_started
		Sketchup.active_model.commit_operation
		@operation_started=false
	end
end
##
def delete_member(view)
if @member and @member.instance.valid?
	model = view.model
	ents = model.active_entities
	ents.erase_entities([@member.instance])
	@member=nil
end
end
####
def place_member(view,undo)
model = view.model
#model.start_operation("Build",true) if undo
entities = model.active_entities
unless @member and (@member.instance.valid?)
	pm=ProfileMember.add(entities,@chain.path)
else
	pm=@member
	trans=pm.transformation
	pm.set_chain(@chain,pm.transformation)
end
pm.set_from_profile!(@profile)
pm.draw()
pm.show   #ensures that the member is displayed (in the case the group has been hidden by PMPI)
@member=pm				#store the newly created group
#model.commit_operation if undo
end
###############################################
# Draw the temporary geometry
def draw_geometry(pt1, pt2, view)
	view.line_width=3
	view.draw_line(pt1, pt2)
	
	vec = pt2 - pt1
	if vec.length>0
		previewer=PMPreviewer.new(view)
		previewer.profile=@profile
		temp_chain=Chain.new
		temp_chain.set_path(@chain.path)
		temp_chain.add(pt2)
		previewer.chain=temp_chain
		previewer.draw(0,0,0)
	end
  
end
end # class Tool
################################
class PMPropertiesSelector   #class to show the dialog for selecting profile member properties to edit or select by
include WebDialogHelper
def initialize(tool,mode)  
@tool=tool  #reference to the ProfileBuilder tool that called the dialog
@mode=mode  #mode must be a string either "edit" or "select"  - this is a test due to asynchronous behaviour of webdialogs on Mac systems
@results=[]
if ON_MAC
	@dlg=UI::WebDialog.new("Member Properties", false, "PB2_Prop_Sel",380,140,387,172,true) #width,height,left,top
else
	@dlg=UI::WebDialog.new("Member Properties", false, "PB2_Prop_Sel",380,180,387,172,true) #width,height,left,top
end
@dlg.set_file(File.join(PATH,"edit.html"))
color = @dlg.get_default_dialog_color 
@dlg.set_background_color(color)
@dlg.add_action_callback("apply_settings") {|d,p|
	model=Sketchup.active_model
	params=p.split("|")
	profile=true if params[0]=="true"
	profile=false if params[0]=="false"
	rotation=true if params[1]=="true"
	rotation=false if params[1]=="false"
	mirror=true if params[2]=="true"
	mirror=false if params[2]=="false"
	pp=true if params[3]=="true"
	pp=false if params[3]=="false"
	x_offset=true if params[4]=="true"
	x_offset=false if params[4]=="false"
	y_offset=true if params[5]=="true"
	y_offset=false if params[5]=="false"
	material=true if params[6]=="true"
	material=false if params[6]=="false"
	layer=true if params[7]=="true"
	layer=false if params[7]=="false"
	
	@results=[profile,rotation,mirror,pp,x_offset,y_offset,material,layer]
	d.close
	if @mode=="edit"
		model.start_operation("Edit Member",true)
		model.set_attribute('ProfileBuilder','PMPSValues',p)
		self.edit_member() if @mode=="edit"
	elsif @mode=="select"
		model.start_operation("Store Properties",true)
		model.set_attribute('ProfileBuilder','PMPSValues',p)
		model.commit_operation
		self.select_by()
	end
	}
@dlg.add_action_callback("cancel") {|d,p| d.close}
		
end
#####
def show
if ON_MAC == true
	@dlg.show_modal{@dlg.bring_to_front;getValuesFromSU();}
else
	@dlg.show{@dlg.bring_to_front;getValuesFromSU();}
end
#@dlg.show_modal{@dlg.bring_to_front;getValuesFromSU();}
end
##############
def edit_member()
model=Sketchup.active_model
model.start_operation("Edit Member",true)
sel=model.selection
tool_profile=@tool.copy_to_profile()
if not @results.empty?
	edited_members=0
	sel.each {|e|
		if Classify.profile_member?(e)
			if e.class==Sketchup::Group
				e.make_unique
			end
			pm=ProfileMember.new(e)
			if @results[0]
				pm.profile=tool_profile 
				e.name=tool_profile.name
				pm.x_scale=tool_profile.x_scale #the stored width must be overwritten if the profile changes
				pm.y_scale=tool_profile.y_scale #the stored height must be overwritten if the profile changes
			end
			pm.rotation=tool_profile.rotation if @results[1]
			pm.mirror=tool_profile.mirror if @results[2]
			pm.placement_point=tool_profile.placement_point if @results[3]
			pm.x_offset=tool_profile.x_offset if @results[4]
			pm.y_offset=tool_profile.y_offset if @results[5]
			pm.material_name=tool_profile.material_name if @results[6]
			pm.layer=tool_profile.layer_name if @results[7]
			
			if pm.revolved?
				pm.revolve()
			else	
				pm.draw()
			end
			edited_members+=1
		end	
	}
	model.commit_operation
	if edited_members==0
		UI.messagebox("没有选择轮廓放样成员.")
	end
else
	model.abort_operatiom
end
end
########
def select_by()
result=self.results
profile=@tool.profile
if not result.empty?
	sel=Sketchup.active_model.selection
	#sel.clear
	p_members=Sketchup.active_model.active_entities.find_all {|e| Classify.profile_member?(e)}
	p_members=p_members.collect {|e| ProfileMember.new(e)}
	if result[0]
		p_members=p_members.find_all {|pm| pm.profile.name==profile.name}
	end
	if result[1]
		p_members=p_members.find_all {|pm| pm.rotation.to_f==profile.rotation.to_f}
	end
	if result[2]
		p_members=p_members.find_all {|pm| pm.mirror==profile.mirror}
	end
	if result[3]
		p_members=p_members.find_all {|pm| pm.placement_point==profile.placement_point}
	end
	if result[4]
		p_members=p_members.find_all {|pm| pm.x_offset.to_f==profile.x_offset.to_f}
	end
	if result[5]
		p_members=p_members.find_all {|pm| pm.y_offset.to_f==profile.y_offset.to_f}
	end
	if result[6]
		p_members=p_members.find_all {|pm| pm.material_name==profile.material_name}
	end
	if result[7]
		p_members=p_members.find_all {|pm| pm.layer_name==profile.layer_name}
	end
	p_members.each {|pm| sel.add(pm.instance) }
	mto=ProfileBuilderMTO.create.refresh_dialog(sel)
end  #end if not result
end
#####
def results
@results
end
#####
def getValuesFromSU()
values=Sketchup.active_model.get_attribute('ProfileBuilder','PMPSValues',nil)
if values
	values=values.split("|")
	values=values.collect {|val| val.to_s}
	checkboxes=["profile","rotation","mirror","placementPoint","xOffset","yOffset","material_name","layer_name"]
	checkboxes.each_index {|i| setCheckbox(checkboxes[i],values[i])}
else
	cmd=""
	@dlg.execute_script(cmd)
end
end
end  #class end
###
class PathExtruder
include Geometry
@@dict="ProfileBuilder"
def initialize()
@ents=Sketchup.active_model.active_entities
@original_points=[]
@path_points=[]
@dimension=2
@holes=[]
@outer_loop=[]
@closed_path=false
@material=nil
@smooth_angle=30.0
@tex_width=1.0
@tex_height=1.0
@has_texture=false
reset()
end
##
def path=(pts)
@path_points=pts.dup
@chain=Chain.new(pts)
if @chain.closed_path?
	@closed_path=true
end
end
##
def profile=(profile)
@profile=profile
@outer_loop=profile.points
@holes=profile.holes
@dimension=@profile.is_2d? ? 2 : 1
end
##
def material=(mat)
@material=mat
if @material
	if @material.texture
		@tex_width=@material.texture.width
		@tex_height=@material.texture.height
		@has_texture=true
		return
	end
end
@tex_width=1.0
@tex_height=1.0
end
#
def smooth_angle=(val)
@smooth_angle=val
end
##
def num_points
return @original_points.length
end
##
def num_path_points
return @path_points.length
end
##
def reset()
@current_extruded_points=[]
@corrected_start_face_pts=[]
@current_edge_index=0
@mesh=Geom::PolygonMesh.new
@current_u_val=0.0
@current_v_val=0.0
@next_u_val=0.0
@next_v_val=0.0
@u_offset=0.0
@smooth_points=[]
@reverse_faces=false
end
##
def extrude_along_path(ents)
@ents=ents
extruded_loop_pts=[]
loops=[@outer_loop].concat(@holes)
loops.each_index {|index|
	
	self.reset()
	@original_points=loops[index].dup
	get_smooth_indices(@original_points)
	
	unless index==0
		@original_points.reverse! #inner loop points are stored in reverse order
		@reverse_faces=true
	end
	
	@current_start_points=@profile.get_transformed_loop(@original_points)
	trans=@chain.transformation_at(0)
	@current_start_points=@current_start_points.collect {|p| p.transform(trans)}
	@uncorrected_start_points=@current_start_points.dup
	extruded_loop_pts[index]=extrude_points_along_path()
}
if !@closed_path
	if @profile.is_2d?
		draw_start_cap_face()
		draw_end_cap_face(extruded_loop_pts)
	else
		draw_start_cap_polyline()
		draw_end_cap_polyline(extruded_loop_pts)
	end
end
end
#
def get_smooth_indices(loop)
num_pts=loop.length
loop.each_index {|i|
	if i==(num_pts-1)
		next_index=0
	else
		next_index=i+1
	end
	next_edge_vec=loop[i].vector_to(loop[next_index])
	previous_edge_vec=loop[i-1].vector_to(loop[i])
	angle=previous_edge_vec.angle_between(next_edge_vec)
	if angle<=(@smooth_angle.degrees)
		@smooth_points.push(i)
	end
}
end
###
def draw_start_cap_face(ents=@ents)
profile_pts=@outer_loop
profile_pts=@profile.get_transformed_loop(profile_pts)
trans=@chain.transformation_at(0)
profile_pts=profile_pts.collect {|p| p.transform(trans)}
#for some weird reason, in rare occasions that make no sense
#sometimes the faces become reverse when materials with textures (uv mapping)
#is applied - this could be a SketchUp bug - this following code checks for reversed
#faces and fixes them
face = ents.add_face(profile_pts)
unless face.normal.samedirection?(trans.zaxis)
	faces=ents.grep(Sketchup::Face)
	faces.each {|f| f.reverse!}
end
@holes.each {|hole|
	hole_pts=@profile.get_transformed_loop(hole)
	hole_pts=hole_pts.collect {|p| p.transform(trans)}
	hole_face=ents.add_face(hole_pts)
	hole_face.erase!
}
face.edges.each {|edge| edge.soft=false;edge.smooth=false}
face.set_attribute(@@dict,'cap_face',true)
face.outer_loop.vertices.each {|v| v.set_attribute(@@dict,'start_cap_face',true)}
face.material=@material
return face
end

###
def draw_end_cap_face(extruded_points)
outer_loop_points=extruded_points[0]
face=@ents.add_face(outer_loop_points)
extruded_points.delete_at(0)
extruded_points.each {|points|
	hole_face=@ents.add_face(points)
	hole_face.erase!
}
face.edges.each {|edge| edge.soft=false;edge.smooth=false}
face.set_attribute(@@dict,'cap_face',true)
face.outer_loop.vertices.each {|v| v.set_attribute(@@dict,'end_cap_face',true)}
face.material=@material
return face
end
#
def draw_start_cap_polyline(ents=@ents)
profile_pts=@outer_loop
profile_pts=@profile.get_transformed_loop(profile_pts)
trans=@chain.transformation_at(0)
profile_pts=profile_pts.collect {|p| p.transform(trans)}
curve_group=ents.add_group
ents=curve_group.entities
edges = ents.add_curve(profile_pts)
edges.each {|edge|
	edge.start.set_attribute(@@dict,'start_cap_face',true)
	edge.end.set_attribute(@@dict,'start_cap_face',true)
	edge.material=@material
}
edges[0].start.set_attribute(@@dict,'polyline_index',0)
curve_group.explode
return edges
end
def draw_end_cap_polyline(extruded_points)
curve_group=@ents.add_group
ents=curve_group.entities
edges = ents.add_curve(extruded_points)
edges.each {|edge|
	edge.start.set_attribute(@@dict,'end_cap_face',true)
	edge.end.set_attribute(@@dict,'end_cap_face',true)
	edge.material=@material
}
curve_group.explode
return edges
end

##
def num_edges()
return @path_points.length-1
end
##
def last_edge()
num_edges=self.num_edges
return [@path_points[num_edges-1],@path_points[num_edges]]
end
def first_edge()
return [@path_points[0],@path_points[1]]
end
##
def current_edge()
return [@path_points[@current_edge_index],@path_points[@current_edge_index+1]]
end
##
def next_edge()
return [@path_points[@current_edge_index+1],@path_points[@current_edge_index+2]]
end
###
def extrude_points_along_path()
self.num_edges.times {|edge_index|
	@current_start_points=get_start_points()
	extrude_vector=get_extrude_vector(edge_index)
	@current_extruded_points=get_extruded_points(@uncorrected_start_points,extrude_vector)
	correct_extruded_points()
	correct_start_points() if @closed_path
	extrude_current_edge()
	@current_edge_index+=1
}
unless @has_texture
	@ents.add_faces_from_mesh(@mesh,Geom::PolygonMesh::AUTO_SOFTEN|Geom::PolygonMesh::SMOOTH_SOFT_EDGES,@material,@material)
end
return @current_extruded_points.dup
end
###
def get_start_points()
#if we haven't extruded anything yet, return the intial starting points
if @current_edge_index==0
	return @current_start_points
else
	return @current_extruded_points.dup
end
end
###
def get_extrude_vector(edge_index)
p1=@path_points[edge_index]
p2=@path_points[edge_index+1]
extrude_vector=p1.vector_to(p2)
return extrude_vector
end
##
def get_extruded_points(pts,vec)
trans=Geom::Transformation.translation(vec)
return pts.collect {|p| p.transform(trans)}
end

##
def correct_extruded_points()
corrected_extruded_face_pts=[]
if current_edge()!=last_edge()
	this_trans=@chain.transformation_at(@current_edge_index)
	this_extrude_vector=get_extrude_vector(@current_edge_index)
	
	next_trans=@chain.transformation_at(@current_edge_index+1)
	next_start_points=@profile.get_transformed_loop(@original_points)
	next_start_points=next_start_points.collect {|p| p.transform(next_trans)}
	
	next_extrude_vector=get_extrude_vector(@current_edge_index+1)
	next_extruded_points=get_extruded_points(next_start_points,next_extrude_vector)
	
	num_points.times {|k|
		p0=@current_start_points[k]
		p1=p0.offset(this_extrude_vector)
		p2=next_start_points[k]
		p3=p2.offset(next_extrude_vector)
		this_edge=[p0,p1]
		next_edge=[p2,p3]
		closest_pts=Geom.closest_points(this_edge,next_edge)
		mid_point=Geom.linear_combination(0.5,closest_pts[0],0.5,closest_pts[1])
		corrected_extruded_face_pts[k]=mid_point
	}
	
	@uncorrected_start_points=next_start_points
	@current_extruded_points=corrected_extruded_face_pts.dup
	#@last_plane=Geom.fit_plane_to_points(corrected_extruded_face_pts)
	#check if new points are behind last plane - if so, ??
	
	
elsif @closed_path
	@current_extruded_points=@corrected_start_face_pts
end
end
###
def correct_extruded_points_void()
corrected_extruded_face_pts=[]
if current_edge()!=last_edge()
	next_start_points=@profile.get_transformed_loop(@original_points)
	trans=@chain.transformation_at(@current_edge_index+1)
	next_start_points=next_start_points.collect {|p| p.transform(trans)}
	
	next_extrude_vector=get_extrude_vector(@current_edge_index+1)
	next_extruded_points=get_extruded_points(next_start_points,next_extrude_vector)
	
	if @chain.point_transformation_at(@current_edge_index+1)==nil
		num_points.times {|k| 
			this_edge=[@current_start_points[k],@current_extruded_points[k]]
			next_edge=[next_start_points[k],next_extruded_points[k]]
			closest_pts=Geom.closest_points(this_edge,next_edge)
			mid_point=Geom.linear_combination(0.5,closest_pts[0],0.5,closest_pts[1])
			corrected_extruded_face_pts[k]=mid_point
		}
		@uncorrected_start_points=next_start_points.dup
	else
		pt_trans=@chain.point_transformation_at(@current_edge_index+1)
		corrected_extruded_face_pts=@profile.get_transformed_loop(@original_points)
		corrected_extruded_face_pts=corrected_extruded_face_pts.collect {|p| p.transform(pt_trans)}
		@uncorrected_start_points=next_start_points.dup
	end
	@current_extruded_points=corrected_extruded_face_pts.dup
	
elsif @closed_path
	@current_extruded_points=@corrected_start_face_pts
end
end
###
def correct_start_points()
if current_edge()==first_edge()
	@corrected_start_face_pts=[]
	last_edge_index=num_edges()-1
	last_start_points=@profile.get_transformed_loop(@original_points)
	last_trans=@chain.transformation_at(last_edge_index)
	last_start_points=last_start_points.collect {|p| p.transform(last_trans)}
	last_extrude_vector=get_extrude_vector(last_edge_index)
	last_extruded_points=get_extruded_points(last_start_points,last_extrude_vector)
	
	num_points.times {|k| 
		this_edge=[last_start_points[k],last_extruded_points[k]]
		next_edge=[@current_start_points[k],@current_extruded_points[k]]
		closest_pts=Geom.closest_points(this_edge,next_edge)
		mid_point=Geom.linear_combination(0.5,closest_pts[0],0.5,closest_pts[1])
		@corrected_start_face_pts[k]=mid_point
	}
	@current_start_points=@corrected_start_face_pts.dup
end
end
###
def extrude_current_edge()

poly1=[]
poly2=[]
current_v_val=0.0
current_u_val=0.0
num_points.times {|j|
	if @dimension==1
		break if j==(num_points-1)
	end
	
	j=j-num_points if j==(num_points-1)
	p0=@current_start_points[j]
	p1=@current_extruded_points[j]
	p2=@current_extruded_points[j+1]
	p3=@current_start_points[j+1]
		
	i0=@mesh.add_point(p0)
	i1=@mesh.add_point(p1)
	i2=@mesh.add_point(p2)
	i3=@mesh.add_point(p3)
		
	#uv mapping code
	l1=[p0,p1]
	l2=[p3,p2]
	pts=Geom.closest_points(l1,l2)
	v_offset=(pts[0].distance(pts[1]))/@tex_height
	next_v_val=current_v_val+v_offset
	
	u1=@current_u_val+(p0.distance(p1)/@tex_width)
	
	v03=p0.vector_to(p3)
	v01=p0.vector_to(p1)
	v01.normalize!
	
	u3=@current_u_val+((v03.dot(v01))/@tex_width)
	u2=u3+(p3.distance(p2)/@tex_width)
	
	uvs=[]
	uvs[0]=[@current_u_val,current_v_val,1]
	uvs[1]=[u1,current_v_val,1]
	uvs[2]=[u2,next_v_val,1]
	uvs[3]=[u3,next_v_val,1]
	
	plane=Geom.fit_plane_to_points([p0,p1,p2])
	if p3.on_plane?(plane)
		poly1=[i0,i1,i2,i3]
		poly1.reverse! if @reverse_faces
		if @has_texture
			face_points=[@mesh.point_at(poly1[0]),@mesh.point_at(poly1[1]),@mesh.point_at(poly1[2]),@mesh.point_at(poly1[3])]
			f=@ents.add_face(face_points)
			pt_array=[p0,uvs[0],p1,uvs[1],p2,uvs[2],p3,uvs[3]]
			f.position_material(@material,pt_array,true)
			f.position_material(@material,pt_array,false)
		else
			face_points=[@mesh.point_at(poly1[0]),@mesh.point_at(poly1[1]),@mesh.point_at(poly1[2]),@mesh.point_at(poly1[3])]
			@mesh.add_polygon(poly1)
		end
		
	else
		poly1=[i0,i1,i2]
		poly2=[i3,i0,i2]
		poly1.reverse! if @reverse_faces
		poly2.reverse! if @reverse_faces
		
		if @has_texture
			f1=@ents.add_face([p0,p1,p2])
			f2=@ents.add_face([p3,p0,p2])
			
			pt_array=[p0,uvs[0],p1,uvs[1],p2,uvs[2]]
			f1.position_material(@material,pt_array,true)
			f1.position_material(@material,pt_array,false)
			
			pt_array=[p3,uvs[3],p0,uvs[0],p2,uvs[2]]
			f2.position_material(@material,pt_array,true)
			f2.position_material(@material,pt_array,false)
		else
			@mesh.add_polygon(poly1)
			@mesh.add_polygon(poly2)
		end
	end
	current_v_val=next_v_val
	@current_u_val=u3 
}
end
###
def fix_vector!(vec)
x=vec.x
y=vec.y
z=vec.z
x=x.abs if x==0.0
y=y.abs if y==0.0
z=z.abs if z==0.0
vec.set!(x,y,z)
end
end #class pathextruder
##
#consider making these methods a part of the Chain class
class Curve
attr_reader :points
def initialize(pts)
self.points=pts
end
##
def edges
arr=[]
num_edges=(@points.length/2.0).to_i
num_edges.times {|i|
	index=i*2
	arr.push([@points[index],@points[index+1]])
}
return arr
end
##
def first_edge
return [@points[0],@points[1]]
end
##
def last_edge
return [@points[-2],@points[-1]]
end
##
def points=(pts)
@points=pts.collect {|p| Geom::Point3d.new(p.x,p.y,p.z)}
end
##
def length
return calc_length(@points)
end
##
def calc_length(pts)
running_length=0.0
(pts.length-1).times {|i|
	p1=pts[i]
	p2=pts[i+1]
	vec=p1.vector_to(p2)
	running_length+=vec.length
}
return running_length

end
##
def flattened_length
flattened_curve_points=flatten_curve(@points)
return calc_length(flattened_curve_points)
end
##
###
def flatten_curve(pts)
pts=pts.collect {|p| p.clone}
pts.each {|p| p.z=0.0}
return pts
end

end #class
end #module PB
end #module DM
