require 'sketchup.rb'
module DM
module ProfileBuilder2
class ProfileLibrary
def initialize(path)
	@path=path
	@profiles=[]
	load(@path)
end
def load(path)
	
	if FileTest.exist?(path)
		@profiles=[]
		@path=path
		begin
			lib=File.new(path,"r")
			lib.each {|line|
				@profiles.push(Profile.new(line)) #add the new profile to the internally stored list
			}
		ensure
			lib.close
		end
		return true
	else
		return false
	end	
end
def add_profile_from_string
end
def find(profile_name)
	#p profile_name
	prof=@profiles.find {|p| p.name==profile_name}
	#p prof
	return prof
end
		
def add(profile)
	@profiles.push(profile)
	@profiles=@profiles.sort
end
def remove(p_name)
	profile=@profiles.find {|p| p.name==p_name}
	@profiles.delete(profile)
	@profiles=@profiles.sort
	self.save()
	return p
end
def replace(old_profile,new_profile)
prof=@profiles.find {|p| p.name==old_profile.name}
if prof
	index=@profiles.index(prof)
	@profiles[index]=new_profile
	return true
else
	return false
end
end
##
def add_profile_from_profile(profile,name)
add(profile)
profile.name=name
return profile
end
def add_profile_from_face(face,name)
	
	p=Profile.new(face)
	p.name=self.get_unique_name(name)
	add(p)
	return p
end
def add_profile_from_chain(chain,name)
	p=Profile.new(chain.path)
	p.name=self.get_unique_name(name)
	add(p)
	return p
end
def to_s
	string=""
	@profiles.each {|p|
		string<<(p.to_s)
	}
	return string
end
def save()
	save_skp()
	return
	begin
		lib=File.new(@path,"w")
		lib.write(self.to_s)
		lib.close
	rescue
		UI.messagebox("Error creating library file.  Ensure you have permission to write to the 'Libraries' folder.")
		raise
	end
end

def profiles
	return @profiles
end
def first
	return @profiles[0]
end
def rename(profile_name,new_name)
	
	p=self.find(profile_name)
	if p==nil
		return nil
	else
		index=@profiles.index(p)
		@profiles[index].name=new_name   #change the name of this profile
		self.save()
	end
	return @profiles[index].name
end
def get_unique_name(name)
	
	i=0
	unique=false
	unique_name=name
	while !unique
	if self.find(unique_name)
		i+=1
		unique_name=name+"#{i}"
	else
		return unique_name
	end
	end
end
end #class end
end #module PB
end #module DM
